; EditLog.sc

PROC EditLogAnyTbl(tblname,nokeys)
 PRIVATE choice,msg

; Procedure parameters:
;   tblname  - name of the table to edit
;   nokeys   - flag to indicate update access to table
;               If True, then IMAGERIGHTS set to UPDATE otherwise no
;              prevention taken to preserve key values.  This also
;              disables insert and delete actions for the table.
;
; Private variables:
;   choice - holds SHOWMENU selection
;   msg    - variable for information message display in WAIT command
;
  EDIT tblname
  IF nokeys = True THEN
    IMAGERIGHTS UPDATE              ;  Prevent modification to key fields
  ENDIF
  msg = ""
  WHILE True
    WAIT TABLE
    PROMPT "EditLog Routine   [F2]-Save   [F10]-Menu",
           "[F3]-Mark   [F4]-Revert   [F5]-Index   [F6]-Permanent"
    MESSAGE msg
    UNTIL "Esc","F2","F3","F4","F5","F6","F10",
          "DOS","DOSBIG","ZOOM","ZOOMNEXT"
    msg = ""
    IF retval = "F10" THEN
      SHOWMENU
        "Mark"      : "Set a marker in the transaction log",
        "Revert"    : "Undo all changes back to the latest MARK",
        "Index"     : "Re-index current changes",
        "Permanent" : "Commit current changes and remain editing the table",
        "Do-It!"    : "Commit current changes and end edit session",
        "Cancel"    : "Cancel the edit session"
      TO choice
      IF choice = "Esc" THEN
        LOOP
      ENDIF
    ELSE
      choice = retval
    ENDIF
    SWITCH
     CASE choice = "F3" OR choice = "Mark"      :
          MESSAGE "Setting marker, Please wait"
          EDITLOG MARK
          msg = "Marker has been placed"
     CASE choice = "F4" OR choice = "Revert"    :
          MESSAGE "Reverting to previous marker, Please wait"
          EDITLOG REVERT
          msg = "Table is reverted to previous marker"
     CASE choice = "F5" OR choice = "Index"     :
          MESSAGE "Re-indexing current changes, Please wait"
          EDITLOG INDEX
          msg = "Indexes have been updated"
     CASE choice = "F6" OR choice = "Permanent" :
          MESSAGE "Committing changes, Please wait"
          EDITLOG PERMANENT
          msg = "Changes have been committed"
     CASE choice = "F2" OR choice = "Do-It!"    :
          MESSAGE "Saving changes, Please wait"
          CANVAS OFF
          DO_IT!
          QUITLOOP
     CASE choice  = "Cancel"   :
          SHOWMENU
            "No"   : "Return to form and continue editing",
            "Yes"  : "Cancel editing process and discard all changed"
          TO choice
          IF choice = "Yes" THEN
            CLEAR
            MESSAGE " Edit canceled, Please wait . . . "
            CANVAS OFF
            CANCELEDIT
            QUITLOOP
          ENDIF
          LOOP
     OTHERWISE                 :
          BEEP
    ENDSWITCH
  ENDWHILE
  IF nokeys = True THEN
    IMAGERIGHTS                     ;  Remove update access only set at
  ENDIF                             ; start of procedure
  CLEARIMAGE
ENDPROC



CLEAR
SHOWTABLES
  DIRECTORY()
  "Select the table to edit"
TO tblname
IF tblname = "Esc" OR tblname = "None" THEN
  QUIT
ENDIF

; need to check for encrypted and write protected tables

EditLogAnyTbl(tblname, True)


RELEASE VARS ALL
