; EntrComp.sc

PROC Beeps()
  BEEP SLEEP 100 BEEP SLEEP 100 BEEP
ENDPROC


PROC ShowMsg(inmsg,ca,clr,slp)
 ; inmsg  -  message to be displayed
 ; ca     -  after message CANVAS option
 ; clr    -  if = Y then CLEAR before message
 ; slp    -  number for use with SLEEP command
 CANVAS ON
 IF clr = "Y" THEN
   CLEAR
 ENDIF
 MESSAGE inmsg
 IF ca = "OFF" THEN
   CANVAS OFF
 ENDIF
 SLEEP slp
ENDPROC



PROC FldBlnk(fldnm,fldtxt)

  EXECUTE "fldblnk = ISBLANK(["+fldnm+"])"
  IF fldblnk THEN
    MOVETO FIELD fldnm
    msg = fldtxt+" must be entered"
    Beeps()
    RETURN True
  ELSE
    RETURN False
  ENDIF
ENDPROC


PROC RqdComps()
 PRIVATE cname,rcd.temp
  IF FldBlnk("Name","Businessr Name") THEN
    RETURN False
  ENDIF
  IF FldBlnk("State","State") THEN
    RETURN False
  ENDIF
; Check for duplicate name
  cname = [Name]
  COPYTOARRAY rcd.temp
  DEL
  MOVETO [Name]
  LOCATE cname
; If LOCATE is successful, then the name of the business is a duplicate
  IF retval = True THEN
    msg = "This business name already exits"
    INS
    COPYFROMARRAY rcd.temp
    Beeps()
    RETURN False
  ELSE
    INS
    COPYFROMARRAY rcd.temp
  ENDIF
  RETURN True
ENDPROC



PROC EnterComps()
  CURSOR OFF
  ShowMsg("Loading form, Please wait","OFF","N",0)

; check for empty table
  IF ISEMPTY("Comps") THEN
    compid = 101
  ELSE
    compid = CMAX("Comps","Business ID") + 1
  ENDIF
  COEDIT "Comps"
  MENU "IP" {1}
  INS
;  READLIB "Prime" RqdComps
  [Business ID] = compid
  compid = compid + 1
  msg = ""
  CANVAS ON
  WHILE TRUE
    WAIT RECORD
      PROMPT "Enter New Company Information   [F2]-Save/Exit   [Esc]-Cancel" +
             "/Exit",
             "[PgDn]-New Company   "
      MESSAGE msg
      UNTIL "F2","PgDn","FieldView","Esc",
            "DOS","DOSBIG","ZOOM","ZOOMNEXT"
    msg = ""
    SWITCH
      CASE retval = "F2" :
           retprocval = RqdComps()
           IF retprocval THEN
             msg = "Saving information, Returning to Main Menu"
             QUITLOOP
           ENDIF
      CASE retval = "PgDn" :
           retprocval = RqdComps()
           IF retprocval THEN
             INS                            ; move to new record
             CtrlHome                       ; move to first field on form
             [Business ID] = compid
             compid = compid + 1
           ENDIF
      CASE retval = "PgUp" :
           retprocval = RqdComps()
           IF retprocval THEN
             CtrlPgUp
           ENDIF
      CASE retval = "Esc" :
           SHOWMENU
             "No"  : "Do not cancel input for this record",
             "Yes" : "Cancel input for this record, Return to Main Menu"
           TO cancelchoice
           IF cancelchoice = "Yes" THEN
             DEL
             msg = "Cancelling input for current record, Returning to Main Menu"
             QUITLOOP
           ENDIF
           LOOP
    ENDSWITCH
  ENDWHILE
  ShowMsg(msg,"OFF","Y",0)
  DO_IT!
  CLEARALL
  RETURN
ENDPROC


EnterComps()
