; Ssedit11.sc

PROC GetOneDept()
 PRIVATE dept
  dept = ""
  @ 0,0 CLEAR EOL                                  ;  Clear the top two lines
  @ 1,0 CLEAR EOL                                  ; of the screen
  ?? "Enter department to edit (Esc to Cancel): "
  STYLE REVERSE                                    ;  Set style for area of
  ACCEPT "A10" PICTURE "*!" TO dept                ; canvas used to input dept
  STYLE                                            ;  IMPORTANT: turn style off
  IF retval = False OR ISBLANK(dept) THEN          ;  If Esc entered, dept = ""
    RETURN False                                   ; return False
  ELSE                                             ; otherwise return value
    RETURN dept                                    ; entered
  ENDIF
ENDPROC

PROC EditDeptData()
  VIEW "Dept"
  MOVETO [Department]
  WHILE True                                       ;  Get the dept to edit.  If
    dept = GetOneDept()                            ; user pressed Esc, cancel
    IF dept = False THEN                           ; processing.  Otherwise
      CLEARIMAGE                                   ; loop until a valid dept
      RETURN "No data selected"                    ; is entered or Esc is
    ELSE                                           ; pressed.
      MESSAGE "Searching for ",dept," department, please wait!"
      CANVAS OFF
    ENDIF
    LOCATE dept
    IF retval = False THEN
      CANVAS ON
      MESSAGE dept + " department does not exist!"
    ELSE
      QUITLOOP
    ENDIF
  ENDWHILE
  COEDITKEY
  PICKFORM 3                                         ;  Form 3 has [Department]
  CANVAS ON                                          ; as DisplayOnly field
  msg = ""
  WHILE True
    WAIT RECORD
      PROMPT "Edit Department Information   [F2]-Save/Exit   [F7]-New Department"
      MESSAGE msg
      UNTIL "F2","F7","DOS","DOSBIG","ZOOM","ZOOMNEXT"
    msg = ""
    SWITCH
      CASE retval = "F7" :                           ;  F7 used to search for
           dept = GetOneDept()                       ; different dept
           IF dept = False OR ISBLANK(dept) THEN     ;  If an Esc or Enter
             msg = "No department selected!"         ; pressed at prompt, no
           ELSE                                      ; data entered so leave
             FORMKEY                                 ; cursor on current dept
             MOVETO [Department]                     ; otherwise search for
             LOCATE dept                             ; dept entered.  If not
             IF retval = False THEN                  ; found, display message.
               msg =  dept +                         ; NOTE: need to toggle
                      " department does not exist!"  ; to table view to move
             ENDIF                                   ; cursor to [Department]
             FORMKEY                                 ; for LOCATE to work
           ENDIF
           LOOP
      CASE retval = "F2" :
           QUITLOOP
      OTHERWISE          :
           BEEP
    ENDSWITCH
  ENDWHILE
  MESSAGE "Editing complete!"
  CANVAS OFF
  DO_IT!
  CLEARIMAGE
ENDPROC


CLEAR
EditDeptData()
