; MTRpts.sc

PROC StartOfPage()
  PRINT "\n",boldon,FORMAT("w80,ac","********** Confidential **********") +
         boldoff,"\n\n"
  PRINT FORMAT("D1",TODAY()) + boldon +
        FORMAT("w64,ac","Employee Personnel Information") + boldoff +
        "Page: " + FORMAT("w4,al",pgnum) + "\n\n"
  linenumber = linenumber + 5
ENDPROC

PROC EndOfPage()
  WHILE linenumber < pagesize - pagefooter
    PRINT "\n"
    linenumber = linenumber + 1
  ENDWHILE
  PRINT boldon,FORMAT("w80,ac","********** Confidential **********"),
        boldoff,"\f"
  pgnum = pgnum + 1
  linenumber = 1
ENDPROC

PROC AddLineNumber(incrmnt)
  IF linenumber + incrmnt > pagesize - pagefooter THEN
     EndOfPage()
     StartOfPage()
  ELSE
    linenumber = linenumber + incrmnt
  ENDIF
ENDPROC

PROC AddBlankLines(numoflines)
 PRIVATE i
  AddLineNumber(numoflines)
  FOR i From 1 TO numoflines
    PRINT "\n"
  ENDFOR
ENDPROC

PROC PrintEmployee()
  AddLineNumber(3)
  PRINT boldon,"Name: ",boldoff,
        [First Name] + " " + [Last Name],gap,
        boldon,"ID: ",boldoff,
        FORMAT("w8,ar",[Employee ID]),gap,"\n\n"
  PRINT boldon,"Department: ",boldoff,
        [Department],gap,
        boldon,"Job Title: ",boldoff,
        [Jobcd->Job Description],"\n"
ENDPROC

PROC PrintBenefits()
  MOVETO "Benefits"
  PRINT boldon,underlineon,"Employee Benefits",underlineoff,boldoff,"\n\n"
  AddLineNumber(5)
  PRINT boldon,"Insurance Type       : ",boldoff,[Insurance Type],"\n"
  PRINT boldon,"Life Insurance       : ",boldoff,
        FORMAT("w12.2,al,e$c",[Life Insurance]),"\n"
  PRINT boldon,"Short Term Disability: ",boldoff,[Short Term Disab],"\n"
  PRINT boldon,"Long Term Disability : ",boldoff,[Long Term Disab],"\n"
  PRINT boldon,"U.S. Saving Bonds    : ",boldoff,
        FORMAT("w10.2,al,e$c",[US Saving Bond]),"\n"
ENDPROC

PROC PrintDepndnts()
 PRIVATE numofdetail
  MOVETO "Depndnts"
  numofdetail = NIMAGERECORDS()
  IF numofdetail = 0 THEN
    RETURN
  ELSE
    AddLineNumber(numofdetail+4)
    PRINT boldon,underlineon,"Employee Dependents",underlineoff,boldoff,"\n\n"
    PRINT boldon,FORMAT("w26","Name"),gap,FORMAT("w11","SSN"),gap,
          "Birth Date","\n"
    PRINT FILL("-",26),gap,FILL("-",11),gap,FILL("-",10),boldoff,"\n"
    SCAN
      PRINT FORMAT("w26",[First Name] + " " + [Last Name]),gap,
            [Dependents SSN],gap,
            [Birth Date],"\n"
    ENDSCAN
  ENDIF
ENDPROC

PROC PrintEducation()
 PRIVATE numofdetail
  MOVETO "Eduction"
  numofdetail = NIMAGERECORDS()
  IF numofdetail = 0 THEN
    RETURN
  ELSE
    AddLineNumber(numofdetail+4)
    PRINT boldon,underlineon,"Employee Education History",
          underlineoff,boldoff,"\n\n"
    PRINT boldon,FORMAT("w4","Year"),gap,FORMAT("w40","School"),gap,
          "Degree","\n"
    PRINT FILL("-",4),gap,FILL("-",40),gap,FILL("-",20),boldoff,"\n"
    SCAN
      PRINT FORMAT("w4",[Year]),gap,
            FORMAT("w40",[School]),gap,
            [Degree],"\n"
    ENDSCAN
  ENDIF
ENDPROC

PROC PrintTraining()
 PRIVATE numofdetail
  MOVETO "Training"
  numofdetail = NIMAGERECORDS()
  IF numofdetail = 0 THEN
    RETURN
  ELSE
    AddLineNumber(numofdetail+4)
    PRINT boldon,underlineon,"Employee Company Training History",
          underlineoff,boldoff,"\n\n"
    PRINT boldon,FORMAT("w3","#"),gap,FORMAT("w40","Course Title"),gap,
          "Date Attended","\n"
    PRINT FILL("-",3),gap,FILL("-",40),gap,FILL("-",13),boldoff,"\n"
    SCAN
      PRINT FORMAT("w3",[Course Number]),gap,
            FORMAT("w40",[Course Title]),gap,
            [Date Attended],"\n"
    ENDSCAN
  ENDIF
ENDPROC

PROC PrintDriver()
 PRIVATE linenumber, pagefooter, gap, pgnum
  linenumber  = 1
  pagefooter = 2
  gap = "  "
  VIEW "Employee"
  PICKFORM 11

  SCAN
    pgnum = 1
    StartOfPage()                           ;  Print page headings
    PrintEmployee()                         ;  Print Employee information
    AddBlankLines(2)
    PrintBenefits()                         ;  Print Benefits information
    AddBlankLines(1)
    PrintDepndnts()                         ;  Print Depndnts information
    AddBlankLines(1)
    PrintEducation()                        ;  Print Eduction information
    AddBlankLines(1)
    PrintTraining()                         ;  Print Training information
    EndOfPage()                             ;  End the current page
    MOVETO "Employee"                       ;  Ensure cursor in Employee Table
  ENDSCAN
  CLEAR
  CLEARALL
ENDPROC

pagesize = 60
boldon   = ""
boldoff  = ""
underlineon = ""
underlineoff = ""
PrintDriver()
