; part editing script
Reset
ClearAll
VIEW "partdesc"
CoEdit "parts"
Menu {Image} {PickForm} {3}
FormKey
msg.text = ""
WHILE true
   CtrlHome Right     ; move to first field in table view
   FirstShow
   ImageRights READONLY
   WAIT TABLE
      PROMPT FORMAT("AL,W6",UserName())+"          F9: Edit part info        Ins: Add new part",
      "                Esc: Leave                Del: Delete part"
      MESSAGE msg.text
   UNTIL "F9","Ins","Del","Esc","Lockkey","Undo"
   ImageRights
   msg.text = ""
   SWITCH
      case retval = "Undo" : if isformview() = false then
                                 goback = "Yes"
                                 FormKey
                             endif
                             UNDO
                             if goback = "Yes" then
                                 FormKey
                             endif
      CASE RETVAL = "F9" :
         if isformview() = false then
               FormKey
         endif
         LockRecord
         IF RETVAL = false THEN
            BEEP
            msg.text = "Record is in use by "+UserName()
         ELSE
            moveto "partdesc"
            ImageRights
            WAIT table
               PROMPT "Make changes, Press F2 when done"
            UNTIL "F2"
            moveto "parts"
            UnLockRecord

            FormKey           ; back to table view
         ENDIF

      CASE RETVAL = "Ins" :
         ImageRights
         FormKey
         Ins
         MOVETO FIELD "PART NUMBER"
         msg.text = ""
         WHILE true
            WAIT FIELD
               PROMPT "Enter new ID, then press Enter",
               "Press Esc to return"
               MESSAGE msg.text
            UNTIL "Enter","Esc","LockKey"
            msg.text = ""
            IF RETVAL = "Enter" AND NOT IsBlank([]) THEN
               LockRecord
               IF RETVAL = false THEN
                  BEEP
                  [] = []  ;; assign the key field to itself, leave KeyViol mode
                  msg.text = "That ID is already in use - use another"
                  LOOP
               ENDIF
               ImageRights UPDATE
               Enter   ; execute the Enter operation, bring user to 2nd field
               WAIT RECORD
                  PROMPT "Add complete record, Press F2 when done"
               UNTIL "F2"
               LockRecord;    ; post the record to the table, then lock it
               UnLockRecord  ;; unlock the record
            ELSE; Esc was pressed, or ID was not filled in
               DEL    ; un-insert the record - "close up the row"
            ENDIF
            FormKey    ;; back to table view
            QUITLOOP
         ENDWHILE

      CASE RETVAL = "Del" :
         if isformview() = false then
              FormKey
         endif
         LockRecord ; lock the record in preparation to delete it
         IF RETVAL = false THEN
            BEEP
            msg.text = "Record is in use by "+UserName()
            UnLockRecord
         ELSE

         MOVETO "PARTDESC" ; moveto detail table (it's in TableView)

          nrecs = imageccount();
          MOVETO "PARTS" ; move back to table being edited
            IF nrecs > 0 THEN
               BEEP
               msg.text = "Cannot delete part record - PARTDESC still exist"
               UnLockRecord
            ELSE
               SHOWMENU
               "Oops!":"Do not delete the record",
               "Delete":"Delete the record"
               TO delete.ok
               IF delete.ok = "Delete" THEN
                  IMAGERIGHTS
                  moveto "partdesc"
                  Del
                  moveto "parts"
                  IMAGERIGHTS
                  DEL
                  msg.text = "Record deleted - Press Ctrl-U to get it back"
               ELSE; user did not want to delete
                  UnLockRecord

               ENDIF
            ENDIF
              FormKey
         ENDIF

      CASE RETVAL = "Esc" :
         QUITLOOP
   ENDSWITCH
ENDWHILE
Do_It!
ClearAll

RELEASE VARS msg.txt, delete.ok, part.id

