
CLEAR
@22,0 ?? "Press Esc to leave"
@ 5,0
TEXT
This program creates a "shadow" of a given table and form.  This is a
technique for avoiding the Form Lock.  Access to the regular and the
"shadow" table must be carefully programmed in PAL.

The "shadow" table is created in a subdirectory named "SHADOW".  This
directory is below the current directory.  If no such subdirectory
exists, this program performs a "MD SHADOW".

Press Enter to begin
ENDTEXT
ACCEPT "a1" TO n
IF RETVAL = false THEN
   RETURN
ENDIF
CLEAR
@ 10,10 ?? "PLEASE WAIT - RETRIEVING A LIST OF TABLES"

{Tools} {Info} {Inventory} {Files} {*.f*}
Menu {Modify} {Restructure} {List} Down DEL Down  "Select"
Enter  "a1" 
Do_It!
{Delete}
Right Rotate EditKey
Menu {ValCheck} {Define} Enter {Picture} {X}

SCAN
   [NAME] = UPPER([NAME])
ENDSCAN
Home

WAIT TABLE 
   PROMPT "Place a X next to each form you want to shadow",
   "Press F2 when done, Esc to leave"
UNTIL "F2","Esc"

Do_It!
IF RETVAL = "Esc" THEN
   ClearAll
   RETURN
ENDIF


@1,0 CLEAR EOL
@0,0 CLEAR EOL
@0,0 ?? "Please wait"

IF DirExists("shadow") = 0 THEN
   @0,0 CLEAR EOL
   @0,0 ?? "Please wait - Creating shadow directory"
   RUN norefresh "md SHADOW"
ENDIF

SCAN FOR [SELECT] = "X"
   x=MATCH([NAME],"..\".F\"..",table.name,form.number)
   IF IsTable("SHADOW\\"+table.name) THEN
      @0,0 CLEAR EOL
      @0,0 ?? "Please wait - Deleting previous shadow for "+table.name
      DELETE "SHADOW\\"+table.name
   ENDIF
ENDSCAN

SCAN FOR [SELECT] = "X"
   x=MATCH([NAME],"..\".F\"..",table.name,form.number)
   @0,0 CLEAR EOL
   @0,0 ?? "Please wait - Creating shadow for "+[NAME]
   {Create} SELECT "SHADOW\\"+table.name
   IF MENUCHOICE() <> "Cancel" THEN
      Menu {Borrow} SELECT table.name
      
      MOVETO FIELD "FIELD TYPE"
      WHILE SUBSTR([],LEN([]),1) = "*" ; remove all keyed fields
         Backspace
         SKIP 1
      ENDWHILE
      Do_It! ; create the table
   ELSE
      {Cancel}
   ENDIF
   IF IsBlank(form.number) THEN
      form.number = "F"
   ENDIF
   COPYFORM table.name form.number "SHADOW\\"+table.name form.number
ENDSCAN

ClearAll

{Tools} {Info} {Inventory} {Files} {shadow\\*.f*}

RETURN "These are the tables and forms that are now in the SHADOW subdirectory"

