CLEARALL
CURSOR OFF
CLEAR
MESSAGE "Defining Procs, Please wait"
CANVAS OFF



PROC CleanTables()
 PRIVATE numofrcds
 MOVETO "Ldepndts"
  numofrcds = NIMAGERECORDS()               ;  Remove current Depndnts record
  FOR i FROM 1 to numofrcds
    DEL
  ENDFOR
  MOVETO "Lbene"                            ;  Remove current Depndnts record
  DEL
  MOVETO "Lemp"                             ;  Remove current Employee record
  DEL
ENDPROC



PROC FetchEmp()
 PRIVATE employee.data
  CleanTables()                             ;  Empty local tables
  SQLFETCH employee.data                    ;  Retrieve employee record
  SQLRELEASE                                ;  Release pending query
  IF retval THEN                            ;  If record retrieved,
    COPYFROMARRAY employee.data             ; place data in Lemp table
    empid = employee.data[2]                ; save Employee Id value
    RETURN True
  ELSE                                      ;  Else no record returned from
    RETURN False                            ; query
  ENDIF
ENDPROC


PROC FetchBene()
 PRIVATE benefits.data
  SQL NOFETCH                               ;  Request benefits data
    select * from benefits
    where employee_id = ~empid~
   ENDSQL
   IF retval = True THEN                    ;  If record retrieved,
     SQLFETCH benefits.data                 ; place record in Lbene record
     COPYFROMARRAY benefits.data
   ENDIF
   SQLRELEASE
   MOVETO "Lemp"
ENDPROC




PROC FetchDepndnts()
 PRIVATE depndnts.data, numofrcds
  SQL NOFETCH                               ;  Retrieve dependents data
    select * from depndnts
    where employee_id = ~empid~
    order by dependents_ssn
   ENDSQL
   IF retval = True THEN                    ;  If data exists,
     SQLFETCH depndnts.data                 ; place each dependents record
     WHILE retval = True                    ; in the Ldepnts table
       COPYFROMARRAY depndnts.data
       DOWN
       SQLFETCH depndnts.data
     ENDWHILE
     DEL                                    ;  Delete blank record
     HOME                                   ;  Move to first record
   ENDIF
   SQLRELEASE                               ;  Release pending query
   MOVETO "Lemp"
ENDPROC


PROC UpdateBenefits()
  SQLSTARTTRANS                             ;  Start a transaction
  SQL                                       ;  Send SQL UPDATE statement
    UPDATE Benefits
      SET Insurance_type   = ~SQLVAL([Insurance_type])~,
          Life_insurance   = ~SQLVAL([Life_insurance])~,
          Short_term_disab = ~SQLVAL([Short_term_disab])~,
          Long_term_disab  = ~SQLVAL([Long_term_disab])~,
          Us_saving_bond   = ~SQLVAL([Us_saving_bond])~
      WHERE Employee_ID = ~[Employee_ID]~
  ENDSQL
  IF SQLERRORCODE() = "0" AND ERRORCODE() = 0 THEN    ;  If no error occurred
    SQLCOMMIT                                         ; commit transaction
    RETURN True
  ELSE
    SQLROLLBACK                                       ; else roll back
    RETURN False                                      ; transaction
  ENDIF
ENDPROC

PROC UpdateDepndnts()                       ;  Start a transaction
  SQLSTARTTRANS                             ;  Send SQL UPDATE statement
  SQL
    UPDATE depndnts
      SET Last_name  = ~SQLVAL([Last_Name])~,
          First_name = ~SQLVAL([First_name])~,
          Birth_date = ~SQLVAL([Birth_date])~
      WHERE Employee_id    = ~SQLVAL([Employee_id])~ AND
            Dependents_ssn = ~SQLVAL([Dependents_ssn])~
  ENDSQL
  IF SQLERRORCODE() = "0" AND ERRORCODE() = 0 THEN    ;  If no error occurred
    SQLCOMMIT                                         ; commit transaction
    RETURN True
  ELSE
    SQLROLLBACK                                       ; else roll back
    RETURN False                                      ; transaction
  ENDIF
ENDPROC

PROC UpdateEmployee()                       ;  Start a transaction
  SQLSTARTTRANS                             ;  Send SQL UPDATE statement
  SQL
    UPDATE employee
      SET Last_Name      = ~SQLVAL([Last_Name])~,
          First_Name     = ~SQLVAL([First_Name])~,
          Date_hired     = ~SQLVAL([Date_hired])~,
          Birth_date     = ~SQLVAL([Birth_date])~,
          Ssn            = ~SQLVAL([Ssn])~,
          Department     = ~SQLVAL([Department])~,
          Job_code       = ~SQLVAL([Job_code])~,
          Work_phone     = ~SQLVAL([Work_phone])~,
          Salary         = ~SQLVAL([Salary])~,
          Exemptions     = ~SQLVAL([Exemptions])~,
          Address        = ~SQLVAL([Address])~,
          City           = ~SQLVAL([City])~,
          State          = ~SQLVAL([State])~,
          Zip            = ~SQLVAL([Zip])~,
          Home_phone     = ~SQLVAL([Home_phone])~,
          Marital_Status = ~SQLVAL([Marital_status])~,
          Sex            = ~SQLVAL([Sex])~
      WHERE Employee_ID = ~[Employee_ID]~
  ENDSQL
  IF SQLERRORCODE() = "0" AND ERRORCODE() = 0 THEN    ;  If no error occurred
    SQLCOMMIT                                         ; commit transaction
    RETURN True
  ELSE
    SQLROLLBACK                                       ; else roll back
    RETURN False                                      ; transaction
  ENDIF
ENDPROC


PROC CheckRcdStat()
 PRIVATE retprocval
  IF RECORDSTATUS("Modified") THEN          ;  If the current record has been
    SWITCH                                  ; modified update server record
      CASE tblname = "Lemp"     : retprocval = UpdateEmployee()
      CASE tblname = "Lbene"    : retprocval = UpdateBenefits()
      CASE tblname = "Ldepndts" : retprocval = UpdateDepndnts()
    ENDSWITCH
    RETURN retprocval                       ;  Return the success or failure
  ELSE                                      ; status of the update
    RETURN True
  ENDIF
ENDPROC




PROC ViewAndEdit3Tables()
 PRIVATE tblname, retkey, msg
  COEDIT "Lemp"
  PICKFORM 3                                ;  Three table form
  SQLRELEASE                                ;  Release any active SQL NOFETCH
  msg    = ""
  SQL NOFETCH                               ;  Rretrieve the employee data
    select * from employee order by employee_id
  ENDSQL
  IF retval = True THEN                     ;  Get first employee record
    FetchEmp()
    IF retval = False THEN
      MESSAGE "No employee records, modification cancelled"
      SLEEP 3000
      RETURN
    ENDIF
    MOVETO "Ldepndts"                       ;  Get dependents data
    FetchDepndnts()
    MOVETO "Lbene"                          ;  Get benefits data
    FetchBene()
    IMAGERIGHTS UPDATE                      ;  Prevent changes to key fields
    CANVAS ON
    WHILE True
      IMAGERIGHTS UPDATE                    ;  Prevent changes to key fields
      WAIT RECORD
        PROMPT "Employee Information  [F2]-Exit  [PgDn]-Next Record  " +
               "[PgUp]-Previous Record",
               "[F3]-Employee Data  [F4]-Benefits Data  [F5]-Dependents Data"
        MESSAGE msg
        UNTIL "F2","F3","F4","F5","PgUp","PgDn",
              "DOS", "DOSBIG", "ZOOM", "ZOOMNEXT"
      retkey = retval
      tblname = TABLE()
      msg = ""
      IMAGERIGHTS                           ;  Need to turn option on to modify
                                            ; key fields for COPYFROMARRAY
                                            ; command in fetch procs

; *************************************************
; *                                               *
; * Data validation should be done here           *
; *                                               *
; *************************************************

      retprocval = CheckRcdStat()           ;  Check to see if the record was
                                            ; was updated, if so, update server
                                            ;  If an error occurred in the
      IF retprocval = False THEN            ; update display message and do
                                            ; not process keystroke
        msg = "Error occurred! SQLERRORMESSAGE: " + SQLERRORMESSAGE() +
              "ERRORMESSAGE: " + ERRORMESSAGE()
        LOOP
      ENDIF
      SWITCH
        CASE retkey = "F3"  :
             MOVETO "Lemp"
             LOOP
        CASE retkey = "F4"  :
             MOVETO "Lbene"
             LOOP
        CASE retkey = "F5" :
             MOVETO "Ldepndts"
             LOOP
        CASE retkey = "PgDn" :
             SWITCH
               CASE tblname = "Lemp" :
                    SQL NOFETCH
                      select * from employee  where employee_id > ~empid~
                       order by employee_id
                    ENDSQL
                    IF retval = True THEN
                      FetchEmp()
                      IF retval = True THEN
                        MOVETO "Lbene"
                        FetchBene()
                        MOVETO "Ldepndts"
                        FetchDepndnts()
                      ELSE
                        BEEP SLEEP 100 BEEP
                        msg = "No more data!"
                      ENDIF
                    ELSE
                      msg = "Select failed!"
                    ENDIF
                    LOOP
               CASE tblname = "Lbene" :
                    BEEP
                    LOOP
               CASE tblname = "Ldepndts" :
                    IF NOT ATLAST() THEN
                       DOWN CTRLHOME
                    ELSE
                       BEEP
                    ENDIF
                    LOOP
             ENDSWITCH
        CASE retkey = "PgUp" :
             SWITCH
               CASE tblname = "Lemp" :
                    SQL NOFETCH
                      select * from employee  where employee_id < ~empid~
                       order by employee_id desc
                    ENDSQL
                    IF retval = True THEN
                      FetchEmp()
                      IF retval THEN
                        MOVETO "Lbene"
                        FetchBene()
                        MOVETO "Ldepndts"
                        FetchDepndnts()
                      ELSE
                        BEEP SLEEP 100 BEEP
                        msg = "No more data!"
                      ENDIF
                    ELSE
                      msg = "Select failed!"
                    ENDIF
                    LOOP
               CASE tblname = "Lbene" :
                    BEEP
                    LOOP
               CASE tblname = "Ldepndts"  :
                    IF NOT ATFIRST() THEN
                       UP CTRLHOME
                    ELSE
                       BEEP
                    ENDIF
                    LOOP
             ENDSWITCH
        CASE retkey = "F2"  :
             CLEAR
             MESSAGE "Saving data, Please wait!"
             CANVAS OFF
             MOVETO "Lbene"
             DEL
             MOVETO "Ldepndts"
             WHILE NIMAGERECORDS() > 1
               DEL
             ENDWHILE
             DEL
             MOVETO "Lemp"
             DEL
             DO_IT!
             QUITLOOP
        OTHERWISE :
             BEEP
      ENDSWITCH
    ENDWHILE
  ELSE
    MESSAGE "Extract failed: ",SQLERRORMESSAGE()
  ENDIF
  CLEARALL
ENDPROC

message "Retrieving data and loading form, Please wait"
CANVAS ON
CANVAS OFF

ViewAndEdit3Tables()
