; ExpldWin.sc

PROC ExplodeWindow(sr,er,sc,ec,clr,brdr,shdw)
 PRIVATE i, midr, midc, rcaspect, numofsteps
;
; Private variables
;   i          -  counter variable
;   midr       -  row midpoint value
;   midc       -  column midpoint value
;   rcaspect   -  row and column aspect ratio
;   numofsteps -  number of steps to explode window
;
; Argument list
;
;   sr         -  starting row position
;   er         -  ending row position
;   sc         -  starting column position
;   ec         -  ending column position
;   clr        -  color to use for the window
;   brdr       -  border flag, "S" for single line, "D" for double line border
;   shdw       -  shadow flag, "Y" to include shadow
;
  midr = ROUND((sr + er)/2,0)
  midc = ROUND((sc + ec)/2,0)
  rcaspect = ROUND(((ec - sc)/(er - sr)) + 1 ,0)
  numofsteps = ROUND((midc - sc)/rcaspect,0)

  PAINTCANVAS ATTRIBUTE clr midr,midc,midr,midc
  FOR i FROM 1 TO numofsteps  - 1
    PAINTCANVAS ATTRIBUTE clr midr-i,midc-rcaspect*i,midr+i,midc+i*rcaspect
  ENDFOR
  PAINTCANVAS ATTRIBUTE clr sr,sc,er,ec
  STYLE ATTRIBUTE clr
  SWITCH
    CASE brdr = "S" :
         PAINTCANVAS FILL "" ATTRIBUTE clr sr,sc+1,sr,ec-1
         PAINTCANVAS FILL "" ATTRIBUTE clr er,sc+1,er,ec-1
         PAINTCANVAS FILL "" ATTRIBUTE clr sr,sc,er,sc
         PAINTCANVAS FILL "" ATTRIBUTE clr sr,ec,er,ec
         @ sr,sc ?? ""
         @ sr,ec ?? ""
         @ er,sc ?? ""
         @ er,ec ?? ""
    CASE brdr = "D" :
         PAINTCANVAS FILL "" ATTRIBUTE clr sr,sc+1,sr,ec-1
         PAINTCANVAS FILL "" ATTRIBUTE clr er,sc+1,er,ec-1
         PAINTCANVAS FILL "" ATTRIBUTE clr sr,sc,er,sc
         PAINTCANVAS FILL "" ATTRIBUTE clr sr,ec,er,ec
         @ sr,sc ?? ""
         @ sr,ec ?? ""
         @ er,sc ?? ""
         @ er,ec ?? ""
  ENDSWITCH
  STYLE
  IF shdw = "Y" THEN
    PAINTCANVAS ATTRIBUTE 7 er+1,sc+2,er+1,ec+2
    PAINTCANVAS ATTRIBUTE 7 sr+1,ec+1,er,ec+2
  ENDIF
ENDPROC
