; Menus.sc

;  This script contains all the procs for the menus of the Personnel System



?? "."
PROC ControlTblsMenu(modetype)
 PRIVATE choice,kp
 WHILE True
      SHOWMENU
        "Dept"     : modetype + " deptartment information",
        "Jobcd"    : modetype + " Jobcd information",
        "Category" : modetype + " budget category information",
        "Crsectgy" : modetype + " course category information",
        "Crsedesc" : modetype + " course description information",
        "Return"      : "Return to Main Menu"
      TO choice
      SWITCH
        CASE choice = "Dept"     : ControlTblsHandler("Dept",modetype)
        CASE choice = "Jobcd"    : ControlTblsHandler("Jobcd",modetype)
        CASE choice = "Category" : ControlTblsHandler("Category",modetype)
        CASE choice = "Crsectgy" : ControlTblsHandler("Crsectgy",modetype)
        CASE choice = "Crsedesc" : ControlTblsHandler("Crsedesc",modetype)
        OTHERWISE                : QUITLOOP
      ENDSWITCH
      CANVAS OFF
      CLEAR
      MainSplash()
      MainMenuSplash()
  ENDWHILE
ENDPROC

WRITELIB libname ControlTblsMenu
RELEASE PROCS ControlTblsMenu

?? "."
PROC EnterMenu()
 PRIVATE choice,kp
 WHILE True
      SHOWMENU
        "Employee"    : "Enter Employee, Benefits, and Dependents information",
        "Budgets"     : "Enter Budgets information",
        "Actuals"     : "Enter Actuals information",
        "Educ/Train"  : "Enter Education and/or Training information",
        "Return"      : "Return to Main Menu"
      TO choice
      SWITCH
        CASE choice = "Employee"   : EnterEmpInfo()
        CASE choice = "Budgets"    : EnterBudOrAct("Budgets")
        CASE choice = "Actuals"    : EnterBudOrAct("Actuals")
        CASE choice = "Educ/Train" : NotDefined()    ;   EnterEducTrain()
        OTHERWISE                  : QUITLOOP
      ENDSWITCH
      CANVAS OFF
      CLEAR
      MainSplash()
      MainMenuSplash()
  ENDWHILE
ENDPROC

WRITELIB libname EnterMenu
RELEASE PROCS EnterMenu

?? "."
PROC GraphMenu()
 PRIVATE choice,kp
 WHILE True
   CANVAS ON
   SHOWMENU
     "SalByGender" :  "Salaries by Gender",
     "BudByDept"   :  "Budgets for each department",
     "ActByDept"   :  "Actuals for each department",
     "ActToBud"    :  "Actuals to Budget comparison for selected year",
     "DeptBud%"    :  "Budget percentage by department for selected year",
     "Return"      :  "Return to Main Menu"
   TO choice
   SWITCH
     CASE choice = "SalByGender" : GraphSalByGndr()
     CASE choice = "BudByDept"   : GraphBudByDept()
     CASE choice = "ActByDept"   : GraphActByDept()
     CASE choice = "ActToBud"    : GraphActToBud()
     CASE choice = "DeptBud%"    : GraphDeptBudPercent()
     OTHERWISE                   : QUITLOOP
   ENDSWITCH
   CANVAS OFF
   CLEAR
   MainSplash()
   MainMenuSplash()
  ENDWHILE
  IF ISFILE("Answer.db") THEN
    DELETE "Answer"
  ENDIF
  IF ISFILE("Crosstab.db") THEN
    DELETE "Crosstab"
  ENDIF
  CLEARALL
ENDPROC

WRITELIB libname GraphMenu
RELEASE PROCS GraphMenu

?? "."
PROC MainMenu(menunum)
 PRIVATE menuitem, kp, choice
  SWITCH
    CASE menunum = 1 :  ViewMenu()
    CASE menunum = 2 :  EnterMenu()
    CASE menunum = 3 :  ModifyMenu()
    CASE menunum = 4 :  QueryMenu()
    CASE menunum = 5 :  ReportMenu()
    CASE menunum = 6 :  GraphMenu()
    CASE menunum = 7 :
         MaintSplash()
         menuitem = VertMenu(startrow,endrow,begcol,endcol,currow,
                             slctclr,nonslctclr)
         MaintMenu(menuitem)
    CASE menunum = 8 :  SHOWMENU
                          "Yes"  :  "Exit application",
                          "No"   :  "Return to menu, do not leave app"
                        TO choice
                        IF choice = "Yes" THEN
                           RELEASE VARS ALL
                           CLEARALL
                           QUIT "Thanks for testing the app"
                        ENDIF
  ENDSWITCH
ENDPROC

WRITELIB libname MainMenu
RELEASE PROCS MainMenu

?? "."
PROC MainMenuSplash()
  CANVAS OFF
  numofitems = 8
  startrow = 10
  endrow = startrow + numofitems - 1
  currow = startrow
  begcol = 32
  endcol = 45
  menumargin  = 32
  slctclr     = 31
  nonslctclr  = 121

  FillWindow(startrow-1,endrow+1,15,65,nonslctclr,"S","Y","Y")
  @ startrow,0
  SETMARGIN  begcol
  STYLE ATTRIBUTE nonslctclr
  TEXT
1. View
2. Enter Data
3. Modify Data
4. Queries
5. Reports                      
6. Graphs
7. Maintenance                  
8. Exit                         
  ENDTEXT
  STYLE
  SETMARGIN OFF
  CANVAS ON
ENDPROC

WRITELIB libname MainMenuSplash
RELEASE PROCS MainMenuSplash

?? "."
PROC MainSplash()
  ExplodeWindow(2,21,4,75,79,"N","Y")
  @ 2,0
  SETMARGIN  8
  STYLE ATTRIBUTE 79
  TEXT

                P a r a d o x   A p p l i c a t i o n


                  P e r s o n n e l   S y s t e m









                     press any key to continue
  ENDTEXT
  STYLE
ENDPROC           ; MainSplash

WRITELIB libname MainSplash
RELEASE PROCS MainSplash

?? "."
PROC MaintMenu(menunum)
 PRIVATE kp
  WHILE True
    SWITCH
      CASE menunum = 1 :
           MESSAGE "System Backup code goes here, Press any key!"
      CASE menunum = 2 :
           MESSAGE "Selected Backup code goes here, Press any key!"
      CASE menunum = 3 :
           MESSAGE "Table pack code goes here, Press any key!"
      OTHERWISE        :  RETURN
    ENDSWITCH
    kp = getchar()
    CANVAS OFF
    CLEAR
    MainSplash()
    MainMenuSplash()
    MaintSplash()
    CANVAS ON
    menunum = VertMenu(startrow,endrow,begcol,endcol,currow,
                       slctclr,nonslctclr)
  ENDWHILE
ENDPROC

WRITELIB libname MaintMenu
RELEASE PROCS MaintMenu

?? "."
PROC MaintSplash()

  CANVAS OFF
  numofitems = 4
  startrow = 11
  endrow = startrow + numofitems - 1
  currow = startrow
  begcol = 35
  endcol = 15 + begcol
  slctclr =    106
  nonslctclr = 44

  FillWindow(startrow-1,endrow+1,begcol-1,endcol+1,44,"S","Y","Y")
  @ startrow,0
  SETMARGIN  begcol
  STYLE ATTRIBUTE nonslctclr
  TEXT
1. Backup     
2. SelectBackup
3. Pack       
4. Return     
  ENDTEXT
  STYLE
  SETMARGIN OFF
  CANVAS ON
ENDPROC

WRITELIB libname MaintSplash
RELEASE PROCS MaintSplash

?? "."
PROC ModifyMenu()
 PRIVATE choice,kp
 WHILE True
      SHOWMENU
        "Employee"    : "Enter Employee, Benefits, and Dependents information",
        "Budgets"     : "Enter Budgets information",
        "Actuals"     : "Enter Actuals information",
        "Educ/Train"  : "Enter Education and/or Training information",
        "ControlTbls" : "Control tables menu",
        "Return"      : "Return to Main Menu"
      TO choice
      SWITCH
        CASE choice = "Employee"   : ModifyTbl("Employee",1)
        CASE choice = "Budgets"    : ModifyTbl("Dept",11)
        CASE choice = "Actuals"    : ModifyTbl("Dept",12)
        CASE choice = "Educ/Train" : ModifyTbl("Employee",2)
        CASE choice = "ControlTbls": ControlTblsMenu("Modify")
        OTHERWISE                  : QUITLOOP
      ENDSWITCH
      CANVAS OFF
      CLEAR
      MainSplash()
      MainMenuSplash()
  ENDWHILE
ENDPROC

WRITELIB libname ModifyMenu
RELEASE PROCS ModifyMenu

?? "."
PROC QueryMenu()
 PRIVATE choice,kp, vi, vci, header, desc1, desc2, descblnk
  header = FORMAT("w80,ac","Queries Menu Description")
  desc1  = FORMAT("w80,ac","This menu allows users to select from the list of available")
  desc2  = FORMAT("w80,ac","queries to answer questions asked on a routine basis.")
  descblnk = FORMAT("w80"," ")

  WHILE (TRUE)
    CLEAR
    ScrnInfo()

    TEXT

  A - One Year Dept Budget Summary
  B - Budget Summary For All Years
  C - Actuals to Budgets Dept/Category
  D - Actuals to Budgets Dept only
  E - Select Emp/Benefits Records         Q - Dynamic Queries
  F - Select Emp/Educ/Training Records
  G - Courses for Selected Category       X - Return to Main Menu

    ENDTEXT
    CURSOR OFF
    WHILE (TRUE)
      IF CHARWAITING() THEN
        vi = GETCHAR()
        IF vi < 0 THEN
          LOOP
        ENDIF
        IF SEARCH(CHR(vi),"ABCDEFGHQX") > 0 THEN  ;  NOTE: SEARCH not case
          QUITLOOP                                ; sensitive.
        ENDIF
      ENDIF
      vtime = TIME()
      @ 0,63  ?? vtime
    ENDWHILE
    vci = UPPER(CHR(vi))
    IF vci = "X" THEN
      QUITLOOP
    ENDIF
    CURSOR NORMAL
    SWITCH
    CASE  vci = "A":
          BudSumForOneYear()
          IF retval = True THEN
            ViewTbl("Answer","")
          ENDIF
    CASE  vci = "B":
          BudSumForAllYears()
          IF retval = True THEN
            ViewTbl("Answer","")
          ENDIF
    CASE  vci = "C":
          ActualsToBudget("All")
          IF retval = True THEN
            ViewTbl("Answer","")
          ENDIF
    CASE  vci = "D":
          ActualsToBudget("Dept")
          IF retval = True THEN
            ViewTbl("Answer","")
          ENDIF
    CASE  vci = "E":
          QueryEmpInfo()
          IF retval = True THEN
            ViewTbl("Answer","1")
          ENDIF
    CASE  vci = "F" :
          QueryEducTrainInfo()
          IF retval = True THEN
            ViewTbl("Answer","1")
          ENDIF
    CASE  vci = "G":
          QueryCategoryCoursesInfo()
          IF retval = True THEN
            ViewTbl("Answer","1")
          ENDIF
    CASE vci = "Q" :
          IF ISRUNTIME() THEN
            Beeps()
            ShowMsg("Dynamic queries does not work in Runtime","OFF","Y",30000)
          ELSE
            QueryAnyTable()
            IF retval = True THEN
              ViewTbl("Answer","")
            ENDIF
          ENDIF
    ENDSWITCH
    CLEARALL
  ENDWHILE
  IF ISFILE("Answer.db") THEN
    DELETE "Answer"
  ENDIF
  IF ISFILE("Crosstab.db") THEN
    DELETE "Crosstab"
  ENDIF
  CLEARALL
  CLEAR
ENDPROC

WRITELIB libname QueryMenu
RELEASE PROCS QueryMenu

?? "."
PROC ReportMenu()
 PRIVATE choice, kp, outdev, rptflg, barsymbol
 WHILE True
   SHOWMENU
     "Roster"          :  "Company Roster report",
     "Budget/Actuals"  :  "Budget to Actuals report",
     "EmpFactSheet"    :  "Employee Fact Sheet (Hardcopy Only)",
     "SalaryComp"      :  "Salary comparison report",
     "Return"          :  "Return to Main Menu"
   TO choice
   IF choice = "Esc" OR choice = "Return" THEN
     RETURN
   ENDIF
   IF choice <> "EmpFactSheet" THEN
     SHOWMENU
       "Screen"  : "Send report to the screen",
       "Printer" : "Send report to the printer"
     TO outdev
   ELSE
     outdev = "Printer"
   ENDIF
   rptflg = 1
   SWITCH
     CASE outdev = "Printer" :
          retprocval = PrinterOn()
          IF retprocval = False THEN
            ShowMsg("Printer not available, output cancelled!","ON","N",2000)
            rptflg = 0
          ENDIF
     CASE outdev = "Esc" :
          rptflg = 0
   ENDSWITCH
   IF rptflg = 1 THEN
     ShowMsg("Sending report to "+outdev+", Please wait!","ON","Y",0)
     SWITCH
       CASE choice = "Roster" :
            {Report} {Output} {Employee} {2} SELECT outdev
       CASE choice = "SalaryComp" :
            barsymbol = "\223"
            {Report} {Output} {Employee} {4} SELECT outdev
       CASE choice = "Budget/Actuals" :
            NotDefined()
       CASE choice = "EmpFactSheet" :
            PLAY "mtrpt"      ; EmpFactSheet()
     ENDSWITCH
   ENDIF
   CANVAS OFF
   CLEAR
   MainSplash()
   MainMenuSplash()
  ENDWHILE
ENDPROC

WRITELIB libname ReportMenu
RELEASE PROCS ReportMenu

?? "."
PROC VertMenu(startrow,endrow,begcol,endcol,currow,slctclr,nonslctclr)
 PRIVATE kp
  PAINTCANVAS ATTRIBUTE slctclr currow,begcol,currow,endcol
  WHILE TRUE
    SYNCCURSOR
    kp = GETCHAR()
    SWITCH
      CASE kp = -80 :   ; Down arrow
           PAINTCANVAS ATTRIBUTE nonslctclr currow,begcol,currow,endcol
           IF currow <> endrow THEN
             currow = currow + 1
           ELSE
             currow = startrow
           ENDIF
           PAINTCANVAS ATTRIBUTE slctclr currow,begcol,currow,endcol
      CASE kp = -72 :   ; Up arrow
           PAINTCANVAS ATTRIBUTE nonslctclr currow,begcol,currow,endcol
           IF currow <> startrow THEN
             currow = currow -1
           ELSE
             currow = endrow
           ENDIF
           PAINTCANVAS ATTRIBUTE slctclr currow,begcol,currow,endcol
      CASE kp = 13 :
            RETURN currow - startrow + 1
      CASE kp = -59 :         ; F1 pressed
           ShowHelp()
      CASE kp = 27  :
           RETURN 0
      OTHERWISE  :
           IF kp >= 49 AND kp <= 49 + numofitems -1 THEN
             PAINTCANVAS ATTRIBUTE nonslctclr currow,begcol,currow,endcol
             currow = startrow + (kp - 49)
             PAINTCANVAS ATTRIBUTE slctclr currow,begcol,currow,endcol
             RETURN currow - startrow + 1
           ELSE
             Beeps()
           ENDIF
    ENDSWITCH
  ENDWHILE
ENDPROC

WRITELIB libname VertMenu
RELEASE PROCS VertMenu

?? "."
PROC ViewMenu()
 PRIVATE choice,kp
 WHILE True
      CANVAS ON
      SHOWMENU
        "Employee"    : "Edit Employee, Benefits, and Dependents information",
        "Budgets"     : "Edit Budgets information",
        "Actuals"     : "Edit Actuals information",
        "Educ/Train"  : "Edit Education and/or Training information",
        "Return"      : "Return to Main Menu"
      TO choice
      SWITCH
        CASE choice = "Employee"   : ViewTbl("Employee",1)
        CASE choice = "Budgets"    : ViewTbl("Dept",11)
        CASE choice = "Actuals"    : ViewTbl("Dept",12)
        CASE choice = "Educ/Train" : ViewTbl("Employee",2)
        OTHERWISE                  : QUITLOOP
      ENDSWITCH
      CANVAS OFF
      CLEAR
      MainSplash()
      MainMenuSplash()
  ENDWHILE
ENDPROC

WRITELIB libname ViewMenu
RELEASE PROCS ViewMenu


