; Prsnl.sc

;  This script contains the processing procedures for Personnel Application

?? "."
PROC ViewTbl(tbl,formnum)
  ShowMsg("Loading information, Please wait!","OFF","Y",0)
  VIEW tbl
  IF NOT ISBLANK(formnum) THEN
    PICKFORM formnum
  ENDIF
  prmpt1 = "Viewing information"
  IF NIMAGES() > 1 THEN
    prmpt2 = "[F2]-Exit   [F3]-Next Table   [F4]-Prev Table   [F7]-Form Toggle"
  ELSE
    prmpt2 = "[F2]-Exit   [F7]-Form Toggle"
  ENDIF
  CANVAS ON
  WHILE True
    WAIT TABLE
      PROMPT prmpt1, prmpt2
      UNTIL "F3","F4","F7","F2","DOS","DOSBIG","ZOOM","ZOOMNEXT"
    SWITCH
      CASE retval = "F3" : DOWNIMAGE
      CASE retval = "F4" : UPIMAGE
      CASE retval = "F7" : FORMKEY
      CASE retval = "F2" : QUITLOOP
      OTHERWISE          : BEEP
    ENDSWITCH
  ENDWHILE
  ShowMsg("Returning to View Menu, Please wait!","OFF","Y",0)
  CLEARALL
ENDPROC

WRITELIB libname ViewTbl
RELEASE PROCS ViewTbl


?? "."
PROC EnterEmpInfo()
  CLEAR
  CURSOR OFF                                      ;  Place informational message
  MESSAGE "Loading form, Please wait"             ; on the screen while form is
  CANVAS OFF                                      ; loading
  IF ISEMPTY("Employee") THEN                     ;  If the table is empty, set
    empid = 1001                                  ; the id counter to 1001
  ELSE                                            ; otherwise calculate the max
    empid = CMAX("Employee","Employee ID") + 1    ; id in the table and add 1.
  ENDIF                                           ; This is used to set Employee
                                                  ; ID.
  MENU {Modify} {DataEntry} {Employee}
  {Image} {Pickform} {1}
  [Employee ID] = empid
  empid = empid + 1
  msg   = ""
  CANVAS ON                                       ;  Need to turn canvas on!
  WHILE True
    IF NOT ISBLANK(msg) THEN                      ;  If there is a message sound
      BEEP SLEEP 100 BEEP SLEEP 100 BEEP          ; the system bell
    ENDIF
    WAIT RECORD
      PROMPT "Enter New Employee Information    [F2]-Save/Exit    [Esc]-Cancel",
             "[F3]-Employee Data    [F4]-Benefits Data     " +
             "[F5]-Dependents Data"
      MESSAGE msg
      UNTIL "F2","F3","F4","F5","Esc","PgDn","PgUp","End","Home",  ; 15 - Ctrl O
            15,-24                                                 ;-24 - Alt O
    retkey = retval                               ;  Save the key pressed
    msg = ""                                      ;  Blank message variable
    tblname = TABLE()
    IF retkey <> "Esc" THEN                       ;  If any key except Esc is
      retprocval = EmpEnterVldyChk(tblname)       ; pressed, check if data is
                                                  ; valid.
      IF NOT retprocval THEN                      ;  If the proc returns False
        LOOP                                      ; the data did not pass the
      ENDIF                                       ; validation rule therefore do
    ELSE                                          ; not process the key pressed
      SHOWMENU
        "No"   : "Return to Data Entry",
        "Yes"  : "Cancel data entry session"
      TO canceloption
      IF canceloption = "Yes" THEN
        CLEAR
        MESSAGE "Data Entry cancelled"
        CANVAS OFF
        CANCELEDIT
        QUITLOOP
      ENDIF
      LOOP
    ENDIF
    SWITCH
      CASE retkey = "F2" :
           CLEAR
           MESSAGE "Saving data, Please wait"
           CANVAS OFF
           MOVETO "Entry1"
           retprocval = ValidityChecks("Entry1")
                                                  ;  Ensure the default values
                                                  ; have been entered for
           MOVETO "Entry"                         ; Benefits table.
           DO_IT!                                 ;  NOTE: need to check for
           QUITLOOP                               ; key violations in Depndnts
      CASE retkey = "F3" : MOVETO "Entry"  LOOP   ;  Moveto Employee Table
      CASE retkey = "F4" : MOVETO "Entry1" LOOP   ;  Moveto Benefits Table
      CASE retkey = "F5" : MOVETO "Entry2" LOOP   ;  Moveto Depndnts Table
      CASE retkey = "PgDn" :
           SWITCH
             CASE tblname = "Entry" :
                  MOVETO "Entry1"
                  retprocval = ValidityChecks("Entry1")
                                                   ;  Ensure the default values
                                                   ; have been entered for
                  MOVETO "Entry"                   ; Benefits table.
                  PgDn                             ;  Moveto next Employee rcd
                  IF ISBLANK([Employee ID]) THEN   ;  If this is a new record
                    [Employee ID] = empid          ; set the Employee ID
                    empid = empid + 1
                  ENDIF
             CASE tblname = "Entry1" :             ;  Only 1 record allowed for
                  BEEP LOOP                        ; Benefits table
             CASE tblname = "Entry2" :             ;  Moveto next record in
                  DOWN CtrlHome                    ; Depndnts table
           ENDSWITCH
      CASE retkey = "PgUp" :
           IF ATFIRST() THEN
             BEEP
             LOOP
           ENDIF
           SWITCH
             CASE tblname = "Entry" :
                  MOVETO "Entry1"
                  retprocval = ValidityChecks("Entry1")
                                                   ;  Ensure the default values
                                                   ; have been entered for
                  MOVETO "Entry"                   ; Benefits table.
                  SKIP -1                          ;  Moveto previous Employee
                                                   ; record.
             CASE tblname = "Entry1" :             ;  Only 1 record allowed for
                  BEEP LOOP                        ; Benefits table
             CASE tblname = "Entry2" :             ;  Moveto previous record in
                  SKIP -1                          ; Depndnts table
           ENDSWITCH
           LOOP
      OTHERWISE:
           IF retkey = 15 OR retkey = -24 THEN    ;  Beep is Alt or Ctrl O
             BEEP                                 ; is pressed
           ELSE
             KEYPRESS retkey
           ENDIF
    ENDSWITCH
  ENDWHILE
  CLEARALL
ENDPROC

WRITELIB libname EnterEmpInfo
RELEASE PROCS EnterEmpInfo

?? "."
PROC EnterBudOrAct(tbl)
 PRIVATE retprocval, msg
  ShowMsg("Loading information, Please wait!","OFF","Y",0)
  COEDIT "Dept"
  IF tbl = "Budgets" THEN
    PICKFORM 11
  ELSE
    PICKFORM 12
  ENDIF
  msg = ""
  SaveRcd()
  CANVAS ON
  WHILE True
    IF NOT ISBLANK(msg) THEN
      BEEP SLEEP 100 BEEP SLEEP 100 BEEP
    ENDIF
    WAIT RECORD
      PROMPT "Editing information",
             "[F2]-Save/Exit   [F3]-" + tbl + " Table  [Ins]-Add Record  " +
             "[Ctrl][U]-Undo"
      MESSAGE msg
      UNTIL "Down","Up","Ins","PgDn","PgUp","F3","UNDO","F2",
            "DOS","DOSBIG","ZOOM","ZOOMNEXT"
    retkey = retval
    msg = ""
    IF retkey <> "UNDO" THEN
      IF TABLE() = tbl THEN                 ;  If not in the Dept table,
        EXECPROC tbl+"VldtyChk"             ; check validation rules for
        IF retval = False THEN              ; current table, if they fail,
          LOOP                              ; loop to WAIT, otherwise
        ENDIF                               ; process keystroke
        retprocval = AnyKeyViol()
        IF retprocval THEN
          LOOP
        ENDIF
      ENDIF
    ENDIF
    SWITCH
      CASE retkey = "Down" : DOWN
      CASE retkey = "Up"   : UP
      CASE retkey = "Ins"  : INS
      CASE retkey = "PgDn" : PGDN
      CASE retkey = "PgUp" : PGUP
      CASE retkey = "F3"   : DOWNIMAGE
      CASE retkey = "UNDO" : UNDO
      CASE retkey = "F2"   : QUITLOOP
      OTHERWISE            : BEEP LOOP
    ENDSWITCH
    SaveRcd()                               ;  Save data of next record
  ENDWHILE
  ShowMsg("Saving data, Returning to Modify Menu, Please wait!","OFF","Y",0)
  DO_IT!
  CLEARALL
ENDPROC

WRITELIB libname EnterBudOrAct
RELEASE PROCS EnterBudOrAct

?? "."
PROC ControlTblsHandler(tbl,modetype)
 PRIVATE retprocval, msg
  ShowMsg("Loading information, Please wait!","OFF","Y",0)
  IF modetype = "Modify" THEN
    COEDIT tbl
  ENDIF
  IF modetype = "View" THEN
    VIEW tbl
  ENDIF
  msg = ""
  SaveRcd()
  CANVAS ON
  WHILE True
    IF NOT ISBLANK(msg) THEN
      BEEP SLEEP 100 BEEP SLEEP 100 BEEP
    ENDIF
    IF modetype = "Modify" THEN
      WAIT RECORD
        PROMPT "Editing information",
               "[F2]-Save/Exit   [Ins]-New Record   [Ctrl][U]-Undo"
        MESSAGE msg
        UNTIL "Down","Up","PgDn","PgUp","INS","UNDO","F2",
              "DOS","DOSBIG","ZOOM","ZOOMNEXT"
    ENDIF
    IF modetype = "View" THEN
      WAIT RECORD
        PROMPT "Viewing information",
               "[F2]-Save/Exit"
        MESSAGE msg
        UNTIL "F2","DOS","DOSBIG","ZOOM","ZOOMNEXT"
    ENDIF
    retkey = retval
    msg = ""
    IF modetype = "Modify" AND retkey <> "UNDO" THEN
      retprocval = AnyKeyViol()
      IF retprocval THEN
        LOOP
      ENDIF
    ENDIF
    SWITCH
      CASE retkey = "PgDn" OR retkey = "Down" :
           EXECPROC tbl+"VldtyChk"
           IF retval = True THEN
             SKIP
             SaveRcd()
           ENDIF
           LOOP
      CASE retkey = "PgUp" OR retkey = "Up" :
           EXECPROC tbl+"VldtyChk"
           IF retval = True THEN
             SKIP -1
             SaveRcd()
           ENDIF
           LOOP
      CASE retkey = "INS"  :
           INS
      CASE retkey = "UNDO" :
           UNDO
           SaveRcd()
      CASE retkey = "F2"   :
           IF modetype = "Modify" THEN
             EXECPROC tbl+"VldtyChk"
             IF retval = True THEN
               QUITLOOP
             ENDIF
             LOOP
           ELSE
             QUITLOOP
           ENDIF
      OTHERWISE            : BEEP
    ENDSWITCH
  ENDWHILE
  ShowMsg("Saving data, Returning to Modify Menu, Please wait!","OFF","Y",0)
  DO_IT!
  CLEARALL
ENDPROC

WRITELIB libname ControlTblsHandler
RELEASE PROCS ControlTblsHandler

?? "."
PROC ModifyTbl(tbl,formnum)
 PRIVATE retprocval, msg
  ShowMsg("Loading information, Please wait!","OFF","Y",0)
  COEDIT tbl
  PICKFORM formnum
  msg = ""
  SaveRcd()
  CANVAS ON
  WHILE True
    IF NOT ISBLANK(msg) THEN
      BEEP SLEEP 100 BEEP SLEEP 100 BEEP
    ENDIF
    WAIT RECORD
      PROMPT "Editing information",
             "[F2]-Save/Exit   [F3]-Next Table   [Ctrl][U]-Undo"
      MESSAGE msg
      UNTIL "PgDn","PgUp","F3","UNDO","F2","DOS","DOSBIG","ZOOM","ZOOMNEXT"
    retkey = retval
    msg = ""
    IF FORMTYPE("DisplayOnly") = False THEN   ;  Check for keyviolations and
      IF RECORDSTATUS("New") = False THEN     ; and validity checks only if
        IF retkey <> "UNDO" THEN              ; current table is not
          retprocval = AnyKeyViol()           ; DisplayOnly and the table
          IF retprocval THEN                  ; has data.  Some detail may be
            LOOP                              ; empty.
          ENDIF
        ENDIF
        EXECPROC TABLE()+"VldtyChk"           ;  Check validation rules for
        IF retval = False THEN                ; current table, if the fail, loop
          LOOP                                ; to WAIT, otherwise process
        ENDIF                                 ; keystroke
      ENDIF
    ENDIF
    SWITCH
      CASE retkey = "PgDn" : SKIP
      CASE retkey = "PgUp" : SKIP -1
      CASE retkey = "F3"   : DOWNIMAGE
      CASE retkey = "UNDO" : UNDO
      CASE retkey = "F2"   : QUITLOOP
      OTHERWISE            : BEEP LOOP
    ENDSWITCH
    SaveRcd()                               ;  Save data of next record
  ENDWHILE
  ShowMsg("Saving data, Returning to Modify Menu, Please wait!","OFF","Y",0)
  DO_IT!
  CLEARALL
ENDPROC

WRITELIB libname ModifyTbl
RELEASE PROCS ModifyTbl


?? "."
PROC ShowHelp()
   @ 24,0 ?? "Help screen information goes here.    Press any key"
   kp = getchar()
   @ 24,0 CLEAR EOL
ENDPROC

WRITELIB libname ShowHelp
RELEASE PROCS ShowHelp


?? "."
PROC PersonnelDriver()
  CURSOR OFF
  startrow = 0
  endrow   = 0
  kp       = 0
  currow   = 0
  begcol   = 0
  endcol   = 0

  numofitmems = 0
  menumargin  = 0

  WHILE True
    CANVAS OFF
    MainSplash()
    MainMenuSplash()
    CANVAS ON
    menuitem = VertMenu(startrow,endrow,begcol,endcol,currow,31,121)
    MainMenu(menuitem)
  ENDWHILE
ENDPROC

WRITELIB libname PersonnelDriver
RELEASE PROCS PersonnelDriver


