; Queries.sc

;  This script contains the query procedures


?? "."
PROC BudSumForOneYear()
 PRIVATE sumyr
  CLEARALL
  CLEAR
  @ 5,0 ?? "Enter the year to summarize: "
  STYLE ATTRIBUTE 33
  ACCEPT "A2" MIN "90" PICTURE "##" TO sumyr
  CURSOR OFF
  STYLE
  CLEAR
  RetrieveMsg("Extracting Budget records for 19" + sumyr)
  CANVAS OFF
  IF sumyr = "Esc" OR ISBLANK(sumyr) THEN
    ShowMsg("No year entered, query cancelled!","OFF","Y",2000)
    RETURN False
  ENDIF

  Query

   Budgets |        Dept                   |  Year  | Q1   | Q2    |
           | Check calc ( _Q1+_Q2+_Q3+_Q4) | ~sumyr | _Q1  | _Q2   |

   Budgets | Q3    | Q4    |
           | _Q3   | _Q4   |

  Endquery
  DO_IT!
  CLEARALL
  IF ISEMPTY("Answer") THEN
    Beeps()
    ShowMsg("No records for 19"+sumyr+", Press any key to continue","OFF",
            "Y",0)
    RETURN False
  ELSE
    Menu {Ask} {Answer} Tab Check Tab  "CALC SUM as Total Budget"
    Do_It!
    CLEARIMAGE
    RETURN True
  ENDIF
ENDPROC

WRITELIB libname BudSumForOneYear
RELEASE PROCS BudSumForOneYear

?? "."
PROC BudSumForAllYears()
  CLEARALL
  CLEAR
  RetrieveMsg("Extracting and summarizing Budget records")
  CANVAS OFF
  Query

   Budgets |        Dept                   |  Year  | Q1   | Q2    |
           | Check calc ( _Q1+_Q2+_Q3+_Q4) | Check  | _Q1  | _Q2   |

   Budgets | Q3    | Q4    |
           | _Q3   | _Q4   |

  Endquery
  DO_IT!
  CLEARALL
  IF ISEMPTY("Answer") THEN
    Beeps()
    ShowMsg("No Budget records, Press any key to continue","OFF",
            "Y",0)
    RETURN False
  ELSE
    Menu {Ask} {Answer} Tab Check Tab Check Tab "CALC SUM as Total Budget"
    Do_It!
    CLEARIMAGE
    RETURN True
  ENDIF
ENDPROC

WRITELIB libname BudSumForAllYears
RELEASE PROCS BudSumForAllYears

?? "."
PROC Act2BudAll()
  Query

   Budgets | Dept | Year | Category |                    Q1                    |
           | _aaa | _ccc | _bbb     | _b1,calc _b1+_b2+_b3+_b4 as Budget Total |

   Budgets | Q2  | Q3  | Q4  |
           | _b2 | _b3 | _b4 |

   Actuals |    Dept     |    Year     |  Category   |                    Q1                     |
           | Check _aaa! | Check _ccc! | Check _bbb! | _a1, calc _a1+_a2+_a3+_a4 as Actual Total |

   Actuals | Q2  | Q3  |                                  Q4                                  |
           | _a2 | _a3 | _a4, calc (_b1+_b2+_b3+_b4)-(_a1+_a2+_a3+_a4) as Under/(Over) Budget |

  Endquery
  DO_IT!
ENDPROC

WRITELIB libname Act2BudAll
RELEASE PROCS Act2BudAll

?? "."
PROC Act2BudDept()
  Query

   Budgets | Dept | Year | Category |                    Q1                    |
           | _aaa | _ccc | _bbb     | _b1,calc _b1+_b2+_b3+_b4 as Budget Total |

   Budgets | Q2  | Q3  | Q4  |
           | _b2 | _b3 | _b4 |

   Actuals |    Dept     |    Year     | Category |                    Q1                     |
           | Check _aaa! | Check _ccc! | _bbb!    | _a1, calc _a1+_a2+_a3+_a4 as Actual Total |

   Actuals | Q2  | Q3  |                                  Q4                                  |
           | _a2 | _a3 | _a4, calc (_b1+_b2+_b3+_b4)-(_a1+_a2+_a3+_a4) as Under/(Over) Budget |

  Endquery
  DO_IT!
  CLEARALL
  Query

   Answer |  Dept  |  Year  |       Budget Total       |       Actual Total        |
          | Check  | Check  | calc sum as Budget Total | calc sum as Actuals Total |

   Answer |        Under/(Over) Budget        |
          | calc sum as "Under/(Over) Budget" |

  Endquery
  DO_IT!
ENDPROC

WRITELIB libname Act2BudDept
RELEASE PROCS Act2BudDept

?? "."
PROC ActualsToBudget(lvl)
  CLEARALL
  CLEAR
  RetrieveMsg("Extracting and summarizing Budget records")
  CANVAS OFF
  IF lvl = "All" THEN
    Act2BudAll()
  ELSE
    Act2BudDept()
  ENDIF
  CLEARALL
  IF ISEMPTY("Answer") THEN
    Beeps()
    ShowMsg("No matching budget & actual records, Press any key to continue",
            "OFF","Y",0)
    RETURN False
  ELSE
    RETURN True
  ENDIF
ENDPROC

WRITELIB libname ActualsToBudget
RELEASE PROCS ActualsToBudget

?? "."
PROC QuestionareEmp(formnum)
  ShowMsg("Loading questinare form, Please wait!","OFF","Y",0)
  EDIT "Question"
  PICKFORM formnum
  DEL                                        ;  Delete old record
  CANVAS ON
  WHILE True
    WAIT RECORD
      PROMPT "Enter selection criteria in any or all fields",
             "[F2]-Select data     [Esc]-Cancel Query"
      UNTIL "F2","Esc","DOS","DOSBIG","ZOOM","ZOOMNEXT"
    SWITCH
      CASE retval = "F2"  :
           QUITLOOP
      CASE retval = "Esc" :
           SHOWMENU
             "No"  : "Do not cancel query, return to form",
             "Yes" : "Cancel query"
           TO canceloption
           IF canceloption = "Yes" THEN
             ShowMsg("Query cancelled, Returning to Query Menu","OFF","Y",0)
             CANCELEDIT
             CLEARALL
             RETURN False
           ENDIF
           LOOP
      OTHERWISE :
           BEEP
    ENDSWITCH
  ENDWHILE
  ShowMsg("Selecting data, Please wait!","OFF","Y",0)
  DO_IT!
ENDPROC

WRITELIB libname QuestionareEmp
RELEASE PROCS QuestionareEmp

?? "."
PROC FillinEmpInfo()
  IF NOT ISBLANK([Question->Employee ID]) THEN
    TYPEIN ", " + [Question->Employee ID]
  ENDIF
  [Last Name]   = [Question->Last Name]
  [First Name]  = [Question->First Name]
  IF NOT ISBLANK([Question->Low Date Hired]) THEN
    IF NOT ISBLANK([Question->High Date Hired]) THEN
      [Date Hired] = ">=" + STRVAL([Question->Low Date Hired]) +
                     ",<=" + STRVAL([Question->High Date Hired])
    ELSE
      [Date Hired] = ">=" + STRVAL([Question->Low Date Hired])
    ENDIF
  ELSE
    IF NOT ISBLANK([Question->High Date Hired]) THEN
      [Date Hired] = "<=" + STRVAL([Question->High Date Hired])
    ENDIF
  ENDIF
  IF NOT ISBLANK([Question->Low Birth Date]) THEN
    IF NOT ISBLANK([Question->High Birth Date]) THEN
      [Birth Date] = ">=" + STRVAL([Question->Low Birth Date]) +
                     ",<=" + STRVAL([Question->High Birth Date])
    ELSE
      [Birth Date] = ">=" + STRVAL([Question->Low Birth Date])
    ENDIF
  ELSE
    IF NOT ISBLANK([Question->High Birth Date]) THEN
      [Birth Date] = "<=" + STRVAL([Question->High Birth Date])
    ENDIF
  ENDIF
  IF NOT ISBLANK([Question->Low Salary]) THEN
    IF NOT ISBLANK([Question->High Salary]) THEN
      [Salary] = ">=" + STRVAL([Question->Low Salary]) +
                     ",<=" + STRVAL([Question->High Salary])
    ELSE
      [Salary] = ">=" + STRVAL([Question->Low Salary])
    ENDIF
  ELSE
    IF NOT ISBLANK([Question->High Salary]) THEN
      [Salary] = "<=" + STRVAL([Question->High Salary])
    ENDIF
  ENDIF
  [Department]     = [Question->Department]
  [Job Code]       = [Question->Job Code]
  [SSN]            = [Question->SSN]
  [City]           = [Question->City]
  [Marital Status] = [Question->Marital Status]
  [Sex]            = [Question->Sex]
ENDPROC

WRITELIB libname FillinEmpInfo
RELEASE PROCS FillinEmpInfo

?? "."
PROC QueryEmpInfo()
 PRIVATE oldqorder
  QuestionareEmp(1)
  IF retval = False THEN
    RETURN False
  ENDIF
  oldqorder = QUERYORDER()
  SETQUERYORDER TABLEORDER
  MENU {Ask} {Employee} CHECK MOVETO [Employee ID] EXAMPLE "id"
  MENU {Ask} {Benefits}       MOVETO [Employee ID] EXAMPLE "id"
  IF NOT ISEMPTY("Question") THEN
    [Insurance Type]   = [Question->Insurance Type]
    [Short Term Disab] = [Question->Short Term Disab]
    [Long Term Disab]  = [Question->Long Term Disab]
    IF NOT ISBLANK([Question->US Saving Bond]) THEN
      [US Saving Bond] = ">" + [Question->US Saving Bond]
    ENDIF
    UPIMAGE                                 ;  Moveto Employee Table
    FillinEmpInfo()
  ENDIF
  DO_IT!
  IF oldqorder = "TableOrder" THEN
    SETQUERYORDER TABLEORDER
  ELSE
    SETQUERYORDER IMAGEORDER
  ENDIF

  CLEARALL
  IF ISEMPTY("Answer") THEN
    Beeps()
    ShowMsg("No data matches selection criteria, Press any key to continue",
            "OFF","Y",0)
    kp = GETCHAR()
    RETURN False
  ELSE
    COPYFORM "Employee" "1" "Answer" "1"
    RETURN True
  ENDIF
ENDPROC

WRITELIB libname QueryEmpInfo
RELEASE PROCS QueryEmpInfo

?? "."
PROC QueryEducTrainInfo()
 PRIVATE oldqorder
  QuestionareEmp(2)
  IF retval = False THEN
    RETURN False
  ENDIF
  oldqorder = QUERYORDER()
  SETQUERYORDER TABLEORDER
  MENU {Ask} {Employee} CHECK MOVETO [Employee ID] EXAMPLE "id"
  MENU {Ask} {Eduction}       MOVETO [Employee ID] EXAMPLE "id"
  MENU {Ask} {Training}       MOVETO [Employee ID] EXAMPLE "id"
  IF NOT ISEMPTY("Question") THEN
    [Course Number] = [Question->Course Number]
    [Course Title]  = [Question->Course Title]
    UPIMAGE                                 ;  Moveto Eduction Table
    IF NOT ISBLANK([Question->Low Year]) THEN
      IF NOT ISBLANK([Question->High Year]) THEN
        [Year] = ">=" + [Question->Low Year] +
                 ",<=" + [Question->High Year]
      ELSE
        [Year] = ">=" + [Question->Low Year]
      ENDIF
    ELSE
      IF NOT ISBLANK([Question->High Year]) THEN
        [Year] = "<=" + [Question->High Year]
      ENDIF
    ENDIF
    [School] = [Question->School]
    [Degree] = [Question->Degree]
    UPIMAGE                                 ;  Moveto Employee Table
    FillinEmpInfo()
  ENDIF
  DO_IT!
  IF oldqorder = "TableOrder" THEN
    SETQUERYORDER TABLEORDER
  ELSE
    SETQUERYORDER IMAGEORDER
  ENDIF

  CLEARALL
  IF ISEMPTY("Answer") THEN
    Beeps()
    ShowMsg("No data matches selection criteria, Press any key to continue",
            "OFF","Y",0)
    kp = GETCHAR()
    RETURN False
  ELSE
    COPYFORM "Employee" "2" "Answer" "1"
    RETURN True
  ENDIF
ENDPROC

WRITELIB libname QueryEducTrainInfo
RELEASE PROCS QueryEducTrainInfo

?? "."
PROC QueryCategoryCoursesInfo()
 PRIVATE category, oldqorder
  ShowMsg("Loading Catgory selection list, Please wait!","OFF","Y",0)
  VIEW "Crsectgy"
  CANVAS ON
  WHILE True
    WAIT TABLE
      PROMPT "Move cursor to the Category you want",
             "[F2]-Select data     [Esc]-Cancel Query"
      UNTIL "F2","Esc","DOS","DOSBIG","ZOOM","ZOOMNEXT"
    SWITCH
      CASE retval = "F2"  :
           QUITLOOP
      CASE retval = "Esc" :
           SHOWMENU
             "No"  : "Do not cancel query, return to form",
             "Yes" : "Cancel query"
           TO canceloption
           IF canceloption = "Yes" THEN
             ShowMsg("Query cancelled, Returning to Query Menu","OFF","Y",0)
             CLEARALL
             RETURN False
           ENDIF
           LOOP
      OTHERWISE :
           BEEP
    ENDSWITCH
  ENDWHILE
  category = [Course Category]
  oldqorder = QUERYORDER()
  ShowMsg("Selecting data, Please wait!","OFF","Y",0)
  MENU {Ask} {Crsectgy} MOVETO [Course Category] EXAMPLE "ct"
  MENU {Ask} {Crsedesc} CHECK MOVETO [Course Category] EXAMPLE "ct"
  TYPEIN ", " + category
  DO_IT!

  IF oldqorder = "TableOrder" THEN
    SETQUERYORDER TABLEORDER
  ELSE
    SETQUERYORDER IMAGEORDER
  ENDIF

  CLEARALL
  IF ISEMPTY("Answer") THEN
    Beeps()
    ShowMsg("No data courses in category" + category +
            ", Press any key to continue","OFF","Y",0)
    kp = GETCHAR()
    RETURN False
  ELSE
    COPYFORM "Crsedesc" "1" "Answer" "1"
    RETURN True
  ENDIF
ENDPROC

WRITELIB libname QueryCategoryCoursesInfo
RELEASE PROCS QueryCategoryCoursesInfo

?? "."
PROC QueryAnyTable()
 PRIVATE tblname, msg
  CLEAR
  SHOWTABLES
  DIRECTORY()
  "Select the table to perform query on, Press Esc to cancel"
  TO tblname

  IF tblname = "Esc" THEN
    @ 22,0
    STYLE ATTRIBUTE 79
    ?? FORMAT("w80,ac","Operation Canceled, returning to Query Menu")
    SLEEP 1500
    STYLE
    @ 22,0 CLEAR EOL
    RETURN
  ENDIF

  MENU {Ask} SELECT tblname

      PROMPT "Enter query specification.  Press Esc to cancel,",
             "F2 to execute"
  msg = ""
  WHILE True
    ECHO NORMAL
    WAIT TABLE
      MESSAGE msg
      UNTIL  "CHECK","CHECKPLUS","CHECKDESCENDING","F2","Esc",
             "DOS","DOSBIG"
    ECHO OFF
    SWITCH
      CASE retval = "CHECK" OR
           retval = "CHECKPLUS" OR
           retval = "CHECKDESCENDING"  :
           KEYPRESS retval
      CASE retval = "F2"   :
           MESSAGE "Executing Query"
           DO_IT!
           msg = WINDOW()
           IF msg = "" THEN
             PROMPT
             CLEARALL
             RETURN True
           ELSE
             LOOP
           ENDIF
      CASE retval = "Esc"  :
           ShowMsg("Query canceled, Returning to Query Menu",
                   "OFF","Y",2000)
           CLEARALL
           RETURN False
    ENDSWITCH
  ENDWHILE
ENDPROC

WRITELIB libname QueryAnyTable
RELEASE PROCS QueryAnyTable

?? "."
PROC ScrnInfo()
  CANVAS OFF
  @ 5,0
  STYLE REVERSE
  ? header
  STYLE ATTRIBUTE 33
  ?? descblnk
  ?? descblnk
  ?? descblnk
  ?? desc1
  ?? desc2
  ?? descblnk
  ?? descblnk
  ?? descblnk
  STYLE
  CANVAS ON
ENDPROC

WRITELIB libname ScrnInfo
RELEASE PROCS ScrnInfo

