;
; Script [ReptMenu]            Type [2nd/3rd Level]    Called from [AnyMenu]
;
; Description [This is a the rport menu for the systems.  It also calls     
;              another menu of specific reports                            ]
;
; Created [04/02/88] By [G.Salcedo ] Revised [__/__/__] By [            ]   
;


 Prevx[Level] = BeginX             ;
 Prevy[Level] = BeginY             ; These get the values from
PrevNC[Level] = NumberChoices      ; the previous menus, so that as
PrevPW[Level] = PopWidth           ; you leave this current menu,
PrevCL[Level] = Color              ; the previous menu can be restored.
PrevN[Level]  = n                  ;

            n = 1
        level = level + 1          ; Increment Level  by 1

       BeginX = Prevx[Level-1]+(n) ; Establish new 'X' and 'Y' values
       BeginY = Prevy[Level-1]+2   ;

NumberChoices = 4                  ; Establish the values to be used
     PopWidth = 20                 ; to build the current menu.
        Color = 31                 ;
MenuName =  "Report Menu "        ;

 Prevx[Level] = BeginX             ; As you pass to another script or
 Prevy[Level] = BeginY             ; procedure, other than another menu,
PrevNC[Level] = NumberChoices      ; you store the 'current' menus values
PrevPW[Level] = PopWidth           ; so that the current menu can be
PrevCL[Level] = Color              ; rebuilt following execution of the
 PrevN[Level] = n                  ; script or procedure.
PrevML[Level] = MenuName           ;


While (true)


; this sets up arrays for all menu choices and the
; corresponding messages.
;
;        C[n] = menu items (the possible choices)
;        D[n] = descriptions of the menu items
;       SC[n] = "top bar" representation of menu item
;       SD[n] = "top bar"      "         "   "     "  description
;     NICK[n] = first letter of menu items

Array         C[NumberChoices]
Array         D[NumberChoices]
Array        SC[NumberChoices]
Array        SD[NumberChoices]
Array      NICK[NumberChoices]

; These are the menu choices and the corresponding "wide" bar (top) display.
; Be sure to enclose the menu item in quotes. The number of characters in the
; menu items should not exceed PopWidth-2. Example "View".

C[1] = "Statements"
D[1] = "Print Statements"

C[2] = "Aging"
D[2] = "Produce AGING report"

C[3] = "Product Report"
D[3] = "Produce Product Report"

C[4] = "Quit"
D[4] = "Exit to the MAIN Menu"


if isassigned(n) = false then
     n = 1
else
     n = n
endif

last = arraysize(c) ; Lets the procedure know the 'bottom' menu choice.

; This sets up the ability to graphically display the present menu level.

PaintBox();DrawPopBox (BeginX,BeginY,NumberChoices,PopWidth,Color,MenuName)
FillMenu()
SelMenu()
if sel = "Esc" then
     @24,0 Clear EOL ?? format("w79,ac","One moment please ...")

             Level = Level - 1      ; As you exit the current menu
            BeginX = Prevx[Level]   ; the values for the previous menu
            BeginY = Prevy[Level]   ; are restored.
     NumberChoices = PrevNC[Level]  ;
          PopWidth = PrevPW[Level]  ; The same restoration appears in the
             Color = PrevCL[Level]  ; following Switch/EndSwitch in the
         MenuName  = PrevML[Level]  ; event the user chooses 'Quit'
                 n = PrevN[Level]   ;

     @24,0 Clear EOL
     reset
     quitloop
else


switch
           case sel = "Esc" :        Level = Level - 1
                                    BeginX = Prevx[Level]
                                    BeginY = Prevy[Level]
                             NumberChoices = PrevNC[Level]
                                  PopWidth = PrevPW[Level]
                                     Color = PrevCL[Level]
                                         n = PrevN[Level]
                                             reset
                                             quitloop
           case sel = c[1]  : play "custstmt"
           case sel = c[2]  : play "aging"
           case sel = c[3]  : play "prntprod"

           case sel = c[4]  :        Level = Level - 1
                                    BeginX = Prevx[Level]
                                    BeginY = Prevy[Level]
                             NumberChoices = PrevNC[Level]
                                  PopWidth = PrevPW[Level]
                                     Color = PrevCL[Level]
                                         n = PrevN[Level]
                                             reset
                                             quitloop
OtherWise:Loop

EndSwitch
endif


EndWhile

