; FillWin.sc

PROC FillWindow(sr,er,sc,ec,clr,brdr,shdw,fillspc)
;
; Argument list
;
;   sr         -  starting row position
;   er         -  ending row position
;   sc         -  starting column position
;   ec         -  ending column position
;   clr        -  color to use for the window
;   brdr       -  border flag, "S" for single line, "D" for double line border
;   shdw       -  shadow flag, "Y" to include shadow
;   fillspc    -  FILL flag, "Y" indicates the area to be painted is to be
;                 cleard using the FILL option with PAINTCANVAS
;
  IF fillspc = "Y" THEN
    PAINTCANVAS FILL " " ATTRIBUTE clr sr,sc,er,ec
  ELSE
    PAINTCANVAS ATTRIBUTE clr sr,sc,er,ec
  ENDIF
  STYLE ATTRIBUTE clr
  SWITCH
    CASE brdr = "S" :
         PAINTCANVAS FILL "" ATTRIBUTE clr sr,sc+1,sr,ec-1
         PAINTCANVAS FILL "" ATTRIBUTE clr er,sc+1,er,ec-1
         PAINTCANVAS FILL "" ATTRIBUTE clr sr,sc,er,sc
         PAINTCANVAS FILL "" ATTRIBUTE clr sr,ec,er,ec
         @ sr,sc ?? ""
         @ sr,ec ?? ""
         @ er,sc ?? ""
         @ er,ec ?? ""
    CASE brdr = "D" :
         PAINTCANVAS FILL "" ATTRIBUTE clr sr,sc+1,sr,ec-1
         PAINTCANVAS FILL "" ATTRIBUTE clr er,sc+1,er,ec-1
         PAINTCANVAS FILL "" ATTRIBUTE clr sr,sc,er,sc
         PAINTCANVAS FILL "" ATTRIBUTE clr sr,ec,er,ec
         @ sr,sc ?? ""
         @ sr,ec ?? ""
         @ er,sc ?? ""
         @ er,ec ?? ""
  ENDSWITCH
  STYLE
  IF shdw = "Y" THEN
    PAINTCANVAS ATTRIBUTE 7 er+1,sc+2,er+1,ec+2
    PAINTCANVAS ATTRIBUTE 7 sr+1,ec+1,er,ec+2
  ENDIF
ENDPROC
