;ͻ
; Script Name: VcPgm.SC   Creation Date: 1/21/88      Author: M. Rudy       
;                         Last Revision: 9/10/90  Revised By: M. Rudy       
;Ķ
; Description: Enters table name, field name, field type, and ValChecks into  
;              a Paradox table for tables selected.                           
;                                                                             
;                                                                             
;                                                                             
;Ķ
; Called By: NONE                                                             
;Ķ
; Libraries: NONE                                                             
;Ķ
; Tables    Forms    Reports  Scripts   Procedures         External Pgms 
;Ķ
; VcCatlg   5        2,3,4                                               
; VcTbls    2,5                                                          
;                                                                        
;                                                                        
;Ķ
;Notes: NONE                                                                  
;                                                                             
;ͼ

PROC ShowMsg(inmsg,ca,clrscrn,slp)
 ; inmsg    -  message to be displayed
 ; ca       -  after message CANVAS option
 ; clrscrn  -  if = Y then CLEAR before message
 ; slp      -  number for use with SLEEP command
   CANVAS ON
   IF clrscrn = "Y" THEN
     CLEAR
   ENDIF
   MESSAGE inmsg
   IF ca = "OFF" THEN
     CANVAS OFF
   ENDIF
   SLEEP slp
ENDPROC


PROC PrinterOn()
 PRIVATE i,kp
  FOR i FROM 1 TO 4
    ShowMsg("Checking to see if the printer is ready, Please wait!",
            "Off","N",0)
    IF PRINTERSTATUS() THEN
      CLEAR
      RETURN True
    ELSE
      IF i = 4 THEN
         RETURN False
      ELSE
        BEEP SLEEP 100 BEEP SLEEP 100 BEEP
        ShowMsg("Printer not on, press any key after turning printer on",
                "Off","N",0)
        kp = GETCHAR()
      ENDIF
    ENDIF
  ENDFOR
ENDPROC

PROC ScreenForm()
  CANVAS OFF
  CLEAR
  @ 2,0
TEXT
ͻ
  V a l C h e c k   C a t a l o g   P r o g r a m  
͹
 Current Directory:                                                           
                                      Working on table:                       
 Total Number of tables:                                                      
 Currently on table #:                                                        
                                                                              
                                                                              
                                                                              
                                                                              
                                                                              
                                                                              
                                                                              
                                                                              
                                                                              
ĺ
                                                                              
                                                                              
ͼ
ENDTEXT
  @ 5,21 ?? UPPER(dirname)
  PAINTCANVAS ATTRIBUTE 78 3,15,3,63
  CANVAS ON
ENDPROC

PROC GetList()
  {Tools} {Info} {Inventory} {Tables} SELECT dirname
  Query

   List |                          Name                          |
        | _tbls, NOT Vccatlg, NOT Vcencrpt, NOT Vctbls, NOT List |

   Vctbls | Table Name |
   INSERT | _tbls      |

  Endquery
  DO_IT!
  MOVETO 1
  CLEARIMAGE
  CLEARIMAGE
ENDPROC

PROC SelectTables()
  EDIT "Vctbls"
  PICKFORM 2
  CLEAR
  CANVAS ON
  WHILE True
    WAIT RECORD
      PROMPT "Select table to include in catalog     [F2]-Save   [Esc]-Cancel ",
             "[F6]-Select Toggle   [Alt][F6]-Select All Tables"
      UNTIL "Up","Down","Enter","CHECK","CHECKPLUS","F2","ESC",
            "DOS","DOSBIG","ZOOM","ZOOMNEXT","INS","DEL"
    SWITCH
      CASE retval = "Enter" OR retval = "Down"       :
           IF NOT ATLAST() THEN
             DOWN
           ELSE
             BEEP
           ENDIF
           LOOP
      CASE retval = "Up"         :
           IF NOT ATFIRST() THEN
             UP
           ELSE
             BEEP
           ENDIF
           LOOP
      CASE retval = "CHECK"      :
           IF ISBLANK([]) THEN
             ""
           ELSE
             CTRLBACKSPACE
           ENDIF
           LOOP
      CASE retval = "CHECKPLUS"  :
           SCAN
             ""
           ENDSCAN
           LOOP
      CASE retval = "F2"         :
           QUITLOOP
      CASE retval = "ESC"        :
           SHOWMENU
             "No"   :  "Return to table selection, do not cancel",
             "Yes"  :  "Cancel table selection, return to Main Menu"
           TO cancelchoice
           IF cancelchoice = "Yes" THEN
             CANVAS OFF
             CLEAR
             MESSAGE "No tables selected, ValCheck catalog creation halted!"
             CANVAS ON
             CANCELEDIT
             RETURN False
           ENDIF
      OTHERWISE                  :  BEEP
    ENDSWITCH
  ENDWHILE
  CLEAR
  MESSAGE "Working, Please wait!"
  CANVAS OFF
  DO_IT!
ENDPROC

PROC RemoveNotSelected()
  Query

   Vctbls | Selection Indicator |
   DELETE | BLANK               |

  Endquery
  DO_IT!
  MOVETO 1
  CLEARIMAGE                                ;  Remove the query image
  DELETE "Deleted"                          ;  Remove Deleted table
ENDPROC

PROC HandleEncrptTables()
 PRIVATE choice, pswd
  VIEW "Vccatlg"
  VIEW "Vctbls"
  VIEW "Vcencrpt"                           ;  Placed last for later code
  EDITKEY
  MOVETO "Vctbls"
  SCAN
    IF ISENCRYPTED([Vctbls->Table Name]) THEN
      MOVETO "Vcencrpt"
      [Table Name] = [Vctbls->Table Name]
      DOWN
      MOVETO "Vctbls"
      [Selection Indicator] = ""            ;  Mark for removal
    ENDIF
  ENDSCAN
  DO_IT!
  IF ISEMPTY("Vcencrpt") THEN
    RETURN
  ELSE
    RemoveNotSelected()                     ;  Remove encrypted tables
    MOVETO "Vcencrpt"
    EDITKEY
    FIRSTSHOW
    CANVAS ON
    WHILE True
      WAIT TABLE
        PROMPT "The following tables are password protected",
               "[F2]-Continue   [Esc]-Cancel   [Del]-Delete Table"
        UNTIL "F2","Del","Esc","Ins","DOS","DOSBIG","ZOOM","ZOOMNEXT"
      SWITCH
        CASE retval = "Del" : DEL LOOP
        CASE retval = "F2"  : QUITLOOP
        CASE retval = "Esc" : CANCELEDIT RETURN
        OTHERWISE           : BEEP LOOP
      ENDSWITCH
    ENDWHILE
    DO_IT!
  ENDIF
  IF ISEMPTY("Vcencrpt") THEN
    MESSAGE "All tables deleted!"
    CANVAS OFF
    CLEARIMAGE
    RETURN
  ENDIF
  HOME
  EDITKEY
  WHILE True
    CANVAS OFF
    @ 1,0 CLEAR EOL ?? "Working on table " + [Table Name]
    @ 0,0 CLEAR EOL ?? "Enter Master Password for " + [Table Name] + ": "
    STYLE ATTRIBUTE 0
    CANVAS ON
    ACCEPT "A15" TO pswd
    STYLE
    PASSWORD pswd
    IF TABLERIGHTS([Table Name],"All") = False THEN
      BEEP SLEEP 100 BEEP
      UNPASSWORD pswd
      MESSAGE "Incorrect or no password entered, selection action from menu!"
      SHOWMENU
        "TryAgain"  : "Enter password again",
        "RemoveTable" : "Remove table from list"
      TO choice
      IF choice = "RemoveTable" THEN
        DEL
      ELSE
        LOOP
      ENDIF
    ELSE
      SKIP
      IF EOT() THEN
        QUITLOOP
      ENDIF
    ENDIF
  ENDWHILE
  DO_IT!
  RemoveNotSelected()                       ;  Remove encrypted tables
  IF NOT ISEMPTY("Vcencrpt") THEN
    ADD "Vcencrpt" "Vctbls"                 ;  Add encrypted tables for which
  ENDIF                                     ; password was supplied
ENDPROC

PROC GetTableNames()
  CANVAS ON
  MESSAGE "Getting list of tables in current directory, Please wait!"
  CANVAS OFF
  GetList()
  SelectTables()
  CLEARALL
  RemoveNotSelected()
  IF ISEMPTY("Vctbls") THEN
    CANVAS OFF
    MESSAGE "No tables selected, ValCheck catalog creation halted!"
    @ 24, 0 ?? " Press any key to continue "
    CANVAS ON
    kp = GETCHAR()
    RETURN False
  ENDIF
  MESSAGE "Checking for encrypted tables, please wait!"
  CANVAS ON
  CANVAS OFF
  CLEARALL                    ; change to remove query image
  HandleEncrptTables()
  ScreenForm()
  RETURN True
ENDPROC


PROC Main()
 PRIVATE tbl, kp

; Private variables
;
;  tbl
;  kp


  @ 7,26 ?? FORMAT("w5,al,ec",NRECORDS("Vctbls"))
  REQUIREDCHECK OFF
  MOVETO "Vctbls"
  SCAN
    CANVAS OFF
    @ 6,57 ?? FORMAT("w8,al",[Table Name])
    @ 8, 26 ?? FORMAT("w5,al,ec",RECNO())
    tbl = [Table Name]
    CANVAS ON
    MESSAGE "Working on " + tbl + " table!"
    CANVAS OFF
    EDIT tbl
    EDITLOG MARK
    MOVETO "Vccatlg"
    IF NOT ISEMPTY("Vccatlg") THEN
      END DOWN
    ENDIF
    MOVETO tbl
    CANVAS ON
    MESSAGE "Getting field names for " + tbl + "!"
    CANVAS OFF
    GetFieldNames(tbl)
    MOVETO tbl
    EDITLOG REVERT                          ;  Undo any changes to table
    DO_IT!
    CLEARIMAGE
    MOVETO "Vctbls"
  ENDSCAN
  CLEARALL
  CANVAS OFF
  MESSAGE "ValCheck Catalog creation complete!"
  @ 24, 0 ?? " Press any key to continue "
  CANVAS ON
  kp = GETCHAR()
ENDPROC                                     ; Main

PROC GetFieldNames(tblname)
 PRIVATE numfields, i, numkeyfields
;
; Private variables
;   numfields    - number of fields in the table
;   i            - variable used as counter
;   numkeyfields - number of key fields for current table

  numfields = NFIELDS(TABLE())
  numkeyfields = NKEYFIELDS(tblname)

  FOR i FROM 1 TO numfields
    RIGHT
    [Vccatlg->Table Name] = tblname
    [Vccatlg->Field #]    = FIELDNO(FIELD(),tblname)
    IF [Vccatlg->Field #] <= numkeyfields THEN
      [Vccatlg->Field Type]  = FIELDTYPE() + "*"
    ELSE
      [Vccatlg->Field Type]  = FIELDTYPE()
    ENDIF
    [Vccatlg->Field Name] = FIELD()
    IF ISFILE(TABLE() + ".VAL") THEN
      MENU {ValCheck} {Define} Enter {LowValue}
      [Vccatlg->LowValue]      = MENUCHOICE()
      ESC {HighValue}
      [Vccatlg->HighValue]     = MENUCHOICE()
      ESC {Default}
      [Vccatlg->Default]       = MENUCHOICE()
      ESC {TableLookup}
      [Vccatlg->TableLookup]   = MENUCHOICE()
      ESC {Picture}
      [Vccatlg->Picture]       = MENUCHOICE()
      REQUIREDCHECK ON
      ESC {Required}
      [Vccatlg->Required]      = MENUCHOICE()
      REQUIREDCHECK OFF
      MENU ESC
    ELSE
      [Vccatlg->Required] = "N"
    ENDIF
    MOVETO "Vccatlg"
    DOWN
    MOVETO tblname
  ENDFOR
ENDPROC

PROC Driver()
 PRIVATE retprocval
  CANVAS ON
  MESSAGE "Setting up system, Please wait!"
  CANVAS OFF
  SETDIR DIRECTORY()
  EMPTY "Vccatlg"
  EMPTY "Vcencrpt"
  EMPTY "Vctbls"
  retprocval = GetTableNames()
  IF retprocval THEN
    Main()
  MENU {Tools} {More} {Protect} {ClearPasswords}
  ENDIF
ENDPROC

PROC ViewCat()
 PRIVATE numoftbls
  MESSAGE "Loading ValCheck Catalog viewing form, Please wait!"
  CANVAS OFF
  CLEAR
  IF ISEMPTY("Vctbls") THEN
    ShowMsg("No tables in catablog","OFF","N",2000)
    RETURN
  ENDIF
  VIEW "Vctbls"
  numoftbls = NRECORDS("Vctbls")
  PICKFORM 5
  CANVAS ON
  WHILE True
    WAIT TABLE
      PROMPT "Viewing ValCheck Catalog",
             "[F2]-Exit   [F3]-Toggle between Tables and Fields listing"
      UNTIL "F2","F3","DOS","DOSBIG","ZOOM","ZOOMNEXT"
    SWITCH
      CASE retval = "F3" :
           DOWNIMAGE
           LOOP
      CASE retval = "F2" :
           CLEAR
           MESSAGE "Returning to Main Menu, Please wait!"
           CANVAS OFF
           CLEARALL
           RETURN
      OTHERWISE          :
           BEEP
    ENDSWITCH
  ENDWHILE
ENDPROC                                     ; ViewCat()


PROC Reports()
 PRIVATE choice, menukp, outdev
  WHILE True
    CANVAS OFF
    CLEAR
    @ 3,0
    TEXT
ͻ
  V a l C h e c k   C a t a l o g   P r o g r a m  
Ķ
  Tables           Table in the catalog                                      
͹
  Fields           Listing of fields                                         
͹
  ValChecks        Listing of ValChecks for each field                       
͹
  Return           Return to the Main Menu                                   
ͼ
  ENDTEXT
  PAINTCANVAS ATTRIBUTE 78 4,15,4,63
  PAINTCANVAS ATTRIBUTE SYSCOLOR(0) 0,0,1,79
  CANVAS ON
  STYLE
  SHOWMENU
    "Tables"     : "Listing of tables in catalog",
    "Fields"     : "Listing of fields in catalog",
    "ValChecks"  : "Listing of fields and ValChecks in catalog",
    "Return"     : "Return to the Main Menu"
  TO choice
  IF choice = "Esc" OR choice = "Return" THEN
    RETURN
  ENDIF
  SHOWMENU
    "Screen"  : "Send report to the screen",
    "Printer" : "Send report to the printer"
  TO outdev
  SWITCH
    CASE outdev = "Printer" :
         retprocval = PrinterOn()
         IF retprocval = False THEN
           MESSAGE("Printer not available, output cancelled!")
           SLEEP 2000
           LOOP
         ENDIF
    CASE outdev = "Esc" :
         LOOP
  ENDSWITCH
  MESSAGE "Sending report to ",outdev,", Please wait!"
  SWITCH
    CASE choice = "Tables" :
         {Report} {Output} {Vccatlg} {2} SELECT outdev
    CASE choice = "Fields" :
         {Report} {Output} {Vccatlg} {4} SELECT outdev
    CASE choice = "ValChecks" :
         {Report} {Output} {Vccatlg} {3} SELECT outdev
  ENDSWITCH
  ENDWHILE
ENDPROC


PROC  MenuScreen()
  CANVAS OFF
  CLEAR
  @ 0,0
  TEXT
View  Reports  Create  Exit
View the ValCheck Catalog

ͻ
  V a l C h e c k   C a t a l o g   P r o g r a m  
Ķ
  View             View the ValCheck Catalog                                 
͹
  Reports          Reports Menu                                              
͹
  Create           Create a ValCheck Catalog for the current directory       
͹
  Exit             Leave the ValCheck Catalog Program                        
ͼ
                                                                     Version 1.3
ENDTEXT
  PAINTCANVAS ATTRIBUTE 78 4,15,4,63
  PAINTCANVAS ATTRIBUTE SYSCOLOR(0) 0,0,1,79
  PAINTCANVAS ATTRIBUTE SYSCOLOR(2) 0,0,0,3
  CANVAS ON
ENDPROC

PROC ChangeDir()
 PRIVATE newdir
  CURSOR NORMAL
  @ 0,0 ?? "Current Diretory: " + dirname
  @ 1,0 ?? "Enter new direcory name ([Esc] to cancel): "
  ACCEPT "A50" TO newdir
  IF NOT retval OR ISBLANK(newdir) THEN
    RETURN
  ENDIF
  WHILE DIREXISTS(newdir) = 0
    MESSAGE " Directory does not exist "
    @ 0,0 CLEAR EOL
    ?? "Enter directory name: "
    ACCEPT "A50" TO newdir
    IF NOT retval OR ISBLANK(newdir) THEN
      RETURN
    ENDIF
  ENDWHILE
  SETDIR newdir
  CURSOR OFF
  dirname = newdir
ENDPROC




ECHO OFF
CURSOR OFF
CLEAR
MESSAGE "Loading, Please wait!"
CANVAS OFF
CLEARALL
RESET
dirname = DIRECTORY()
SETDIR dirname                                ; change directory to current
                                              ; directory to clear temporary
                                              ; tables

WHILE True
MenuScreen()
SHOWMENU
"View"      : "View the ValCheck Catalog",
"Reports"   : "Reports Menu",
"Create"    : "Create a ValCheck Catalog for the current directory",
"Exit"      : "Leave the ValCheck Catalog Program"
TO choice
IF choice = "Esc" OR choice = "Exit" THEN
  SHOWMENU
   "No"  : "Do not leave ValCheck Catalog Program",
   "Yes" : "Leave ValCheck Catalog Program"
  TO choice2
  IF choice2 = "Yes" THEN
    QUIT
  ELSE
    LOOP
  ENDIF
ELSE
  SWITCH
    CASE choice = "Create"    : Driver()
    CASE choice = "View"      : ViewCat()
    CASE choice = "Reports"   : Reports()
  ENDSWITCH
ENDIF
ENDWHILE

